#include <ansi_c.h>
#include <cvirte.h>		/* Needed if linking in external compiler; harmless otherwise */
#include <userint.h>
#include "sig_utils.h"
#include <uut_util.h>
#include "interface.h"
#include <lsa_tools.h>






int  CVICALLBACK ChgMDX_reg0(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	unsigned int data;		   
	char cmdBuf[1024], dataBuf[1024]; 
    unsigned short MDX_reg = 0;
    
   
   if (event != EVENT_COMMIT) 
   	return 0;              									   

		// Channel 1 MDX register
		GetCtrlVal(panel, MDX_WRITE16BIT, &data);
			if (data)
			{
				MDX_reg |=0x0001;
			}
		GetCtrlVal(panel, MDX_CPUMTBWRDSEL, &data);
			if (data)
			{
				MDX_reg |=0x0002;
			}
		GetCtrlVal(panel, MDX_ADCMEMINSEL, &data);
			if (data)
			{
				MDX_reg |=0x0004;
			}
		GetCtrlVal(panel, MDX_MMMODSEL_0, &data);
			if (data)
			{
				MDX_reg |=0x0008;
			}
		GetCtrlVal(panel, MDX_MMMODSEL_1, &data);
			if (data)
			{
				MDX_reg |=0x0010;
			}
		GetCtrlVal(panel, MDX_MTBRW, &data);
			if (data)
			{
				MDX_reg |=0x0020;
			}
		GetCtrlVal(panel, MDX_SNOOP, &data);
			if (data)
			{
				MDX_reg |=0x0040;
			}
		GetCtrlVal(panel, MDX_SWAPAB, &data);
			if (data)
			{
				MDX_reg |=0x0080;
			}
		
		// Channel 2 MDX register
		GetCtrlVal(panel, MDX_WRITE16BIT_2, &data);
			if (data)
			{
				MDX_reg |=0x0100;
			}
		GetCtrlVal(panel, MDX_CPUMTBWRDSEL_2, &data);
			if (data)
			{
				MDX_reg |=0x0200;
			}
		GetCtrlVal(panel, MDX_ADCMEMINSEL_2, &data);
			if (data)
			{
				MDX_reg |=0x0400;
			}
		GetCtrlVal(panel, MDX_MMMODSEL_2_0, &data);
			if (data)
			{
				MDX_reg |=0x0800;
			}
		GetCtrlVal(panel, MDX_MMMODSEL_2_1, &data);
			if (data)
			{
				MDX_reg |=0x1000;
			}
		GetCtrlVal(panel, MDX_MTBRW_2, &data);
			if (data)
			{
				MDX_reg |=0x2000;
			}
		GetCtrlVal(panel, MDX_SNOOP_2, &data);
			if (data)
			{
				MDX_reg |=0x4000;
			}
		GetCtrlVal(panel, MDX_SWAPAB_2, &data);
			if (data)
			{
				MDX_reg |=0x8000;
			}
			
			// format and write register 0 command
			sprintf (cmdBuf, "$$HA_MEMORY WORD, 23100000, %x ", MDX_reg);
			WriteDevice (cmdBuf);
			//printf ("%s \n", cmdBuf);



	return 0;
}

int  CVICALLBACK ChgMDX_reg1(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	unsigned int data1, data2;		   
	char cmdBuf[1024], dataBuf[1024]; 
    unsigned short MDX_reg = 0;
    
   
   if (event != EVENT_COMMIT) 
   	return 0;              									   

		// Channel 1 MDX register 1
		GetCtrlVal(panel, MDX_BYTE0TO7OEN, &data1);

		// Channel 2 MDX register 1 
		GetCtrlVal(panel, MDX_BYTE0TO7OEN_2, &data2);
		data2 <<= 8;		
		MDX_reg = (data1 | data2);
		// format and write register 0 command
		sprintf (cmdBuf, "$$HA_MEMORY WORD, 23100002, %x ", MDX_reg);
		WriteDevice (cmdBuf);
		//printf ("%s \n", cmdBuf);



	return 0;
}

int  CVICALLBACK ChgMDX_reg2(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	unsigned int data;		   
	char cmdBuf[1024], dataBuf[1024]; 
    unsigned short MDX_reg = 0;
    
   
   if (event != EVENT_COMMIT) 
   	return 0;              									   

		// Channel 1 MDX register 2
		GetCtrlVal(panel, MDX_INVA, &data);
			if (data)
			{
				MDX_reg |=0x0001;
			}
		GetCtrlVal(panel, MDX_INVB, &data);
			if (data)
			{
				MDX_reg |=0x0002;
			}
		GetCtrlVal(panel, MDX_FLIPA, &data);
			if (data)
			{
				MDX_reg |=0x0004;
			}
		GetCtrlVal(panel, MDX_FLIPB, &data);
			if (data)
			{
				MDX_reg |=0x0008;
			}
		GetCtrlVal(panel, MDX_BIN2GRAY, &data);
			if (data)
			{
				MDX_reg |=0x0010;
			}
		GetCtrlVal(panel, MDX_GRAY2BIN, &data);
			if (data)
			{
				MDX_reg |=0x0020;
			}
		GetCtrlVal(panel, MDX_REVBIT_0, &data);
			if (data)
			{
				MDX_reg |=0x0040;
			}
		GetCtrlVal(panel, MDX_REVBIT_1, &data);
			if (data)
			{
				MDX_reg |=0x0080;
			}
		
		// Channel 2 MDX register 2
		GetCtrlVal(panel, MDX_INVA_2, &data);
			if (data)
			{
				MDX_reg |=0x0100;
			}
		GetCtrlVal(panel, MDX_INVB_2, &data);
			if (data)
			{
				MDX_reg |=0x0200;
			}
		GetCtrlVal(panel, MDX_FLIPA_2, &data);
			if (data)
			{
				MDX_reg |=0x0400;
			}
		GetCtrlVal(panel, MDX_FLIPB_2, &data);
			if (data)
			{
				MDX_reg |=0x0800;
			}
		GetCtrlVal(panel, MDX_BIN2GRAY_2, &data);
			if (data)
			{
				MDX_reg |=0x1000;
			}
		GetCtrlVal(panel, MDX_GRAY2BIN_2, &data);
			if (data)
			{
				MDX_reg |=0x2000;
			}
		GetCtrlVal(panel, MDX_REVBIT_2_0, &data);
			if (data)
			{
				MDX_reg |=0x4000;
			}
		GetCtrlVal(panel, MDX_REVBIT_2_1, &data);
			if (data)
			{
				MDX_reg |=0x8000;
			}
			
			// format and write register 0 command
			sprintf (cmdBuf, "$$HA_MEMORY WORD, 23100004, %x ", MDX_reg);
			WriteDevice (cmdBuf);
			//printf ("%s \n", cmdBuf);



	return 0;
}

int  CVICALLBACK ChgMDX_reg3(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	unsigned int data;		   
	char cmdBuf[1024], dataBuf[1024]; 
    unsigned short MDX_reg = 0;
    
   
   if (event != EVENT_COMMIT) 
   	return 0;              									   

		// Channel 1 MDX register 3
		GetCtrlVal(panel, MDX_INVMSB, &data);
			if (data)
			{
				MDX_reg |=0x0001;
			}
		// Bit 1 is not used
		GetCtrlVal(panel, MDX_MEMDELAY_0, &data);
			if (data)
			{
				MDX_reg |=0x0004;
			}
		GetCtrlVal(panel, MDX_MEMDELAY_1, &data);
			if (data)
			{
				MDX_reg |=0x0008;
			}
		GetCtrlVal(panel, MDX_ADRSDELAY_0, &data);
			if (data)
			{
				MDX_reg |=0x0010;
			}
		GetCtrlVal(panel, MDX_ADRSDELAY_1, &data);
			if (data)
			{
				MDX_reg |=0x0020;
			}
		GetCtrlVal(panel, MDX_ADRSDIV_0, &data);
			if (data)
			{
				MDX_reg |=0x0040;
			}
		GetCtrlVal(panel, MDX_ADRSDIV_1, &data);
			if (data)
			{
				MDX_reg |=0x0080;
			}
		
		// Channel 2 MDX register 2
		GetCtrlVal(panel, MDX_INVMSB_2, &data);
			if (data)
			{
				MDX_reg |=0x0100;
			}
		// Bit 2 is not used
		GetCtrlVal(panel, MDX_MEMDELAY_2_0, &data);
			if (data)
			{
				MDX_reg |=0x0400;
			}
		GetCtrlVal(panel, MDX_MEMDELAY_2_1, &data);
			if (data)
			{
				MDX_reg |=0x0800;
			}
		GetCtrlVal(panel, MDX_ADRSDELAY_2_0, &data);
			if (data)
			{
				MDX_reg |=0x1000;
			}
		GetCtrlVal(panel, MDX_ADRSDELAY_2_1, &data);
			if (data)
			{
				MDX_reg |=0x2000;
			}
		GetCtrlVal(panel, MDX_ADRSDIV_2_0, &data);
			if (data)
			{
				MDX_reg |=0x4000;
			}
		GetCtrlVal(panel, MDX_ADRSDIV_2_1, &data);
			if (data)
			{
				MDX_reg |=0x8000;
			}
			
			// format and write register 0 command
			sprintf (cmdBuf, "$$HA_MEMORY WORD, 23100006, %x ", MDX_reg);
			WriteDevice (cmdBuf);
			//printf ("%s \n", cmdBuf);



	return 0;
}

int  CVICALLBACK ChgMDX_reg4(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	unsigned int data1, data2;		   
	char cmdBuf[1024], dataBuf[1024]; 
    unsigned short MDX_reg = 0;
    
   
   if (event != EVENT_COMMIT) 
   	return 0;              									   

		// Channel 1 MDX register 1
		GetCtrlVal(panel, MDX_STARTADDRESS, &data1);

		// Channel 2 MDX register 1 
		GetCtrlVal(panel, MDX_STARTADDRESS_2, &data2);
		data2 <<= 8;		
		MDX_reg = (data1 | data2);
		// format and write register 0 command
		sprintf (cmdBuf, "$$HA_MEMORY WORD, 23100008, %x ", MDX_reg);
		WriteDevice (cmdBuf);
		



	return 0;
}

int  CVICALLBACK exitMDXpanel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2) 
{		
   if (event != EVENT_COMMIT) 
   	return 0;              									   
		
	DiscardPanel (gMDXPanelHandle);
	SetCtrlAttribute (gMainPanelHandle, MAIN_PANEL_MDX_BTN, ATTR_DIMMED, 0);
	return 0;
}

// This function is called when READ button is pressed in REGISTER 0 
int CVICALLBACK readReg0 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    
    char cmdBuf[512], MDX_reg[512];
    unsigned int regVal;
    
    if (event != EVENT_COMMIT) 
   	return 0;              									   
	
	sprintf (cmdBuf, "$$HA_MEMORY? WORD, 23100000, 1");
	WriteDevice (cmdBuf);
	//printf ("%s \n", cmdBuf);
	ReadDevice(MDX_reg, 512);
	//printf ("%s \n", MDX_reg);

	sscanf(MDX_reg, "WORD,23100000,%x", &regVal); 		
	
	// MDX channel 1 register 0
	SetCtrlVal(panel, MDX_WRITE16BIT, (regVal &0x0001) == 0x0001);
	SetCtrlVal(panel, MDX_CPUMTBWRDSEL, (regVal &0x0002) == 0x0002);			
	SetCtrlVal(panel, MDX_ADCMEMINSEL, (regVal &0x0004) == 0x0004);
	SetCtrlVal(panel, MDX_MMMODSEL_0, (regVal &0x0008) == 0x0008);
	SetCtrlVal(panel, MDX_MMMODSEL_1, (regVal &0x0010) == 0x0010);
	SetCtrlVal(panel, MDX_MTBRW, (regVal &0x0020) == 0x0020);
	SetCtrlVal(panel, MDX_SNOOP, (regVal &0x0040) == 0x0040);			   	   
	SetCtrlVal(panel, MDX_SWAPAB, (regVal &0x0080) == 0x0080);

	// MDX channel 2 register 0
	SetCtrlVal(panel, MDX_WRITE16BIT_2, (regVal &0x0100) == 0x0100);
	SetCtrlVal(panel, MDX_CPUMTBWRDSEL_2, (regVal &0x0200) == 0x0200);			
	SetCtrlVal(panel, MDX_ADCMEMINSEL_2, (regVal &0x0400) == 0x0400);
	SetCtrlVal(panel, MDX_MMMODSEL_2_0, (regVal &0x0800) == 0x0800);
	SetCtrlVal(panel, MDX_MMMODSEL_2_1, (regVal &0x1000) == 0x1000);
	SetCtrlVal(panel, MDX_MTBRW_2, (regVal &0x2000) == 0x2000);
	SetCtrlVal(panel, MDX_SNOOP_2, (regVal &0x4000) == 0x4000);			   	   
	SetCtrlVal(panel, MDX_SWAPAB_2, (regVal &0x8000) == 0x8000);
	
	return 0;
}

// This function is called when READ button is pressed in REGISTER 1    
int CVICALLBACK readReg1 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    char cmdBuf[512], MDX_reg[512];
    unsigned int regVal, regVal1, regVal2;
    
    if (event != EVENT_COMMIT) 
   	return 0;              									   
	sprintf (cmdBuf, "$$HA_MEMORY? WORD, 23100002, 1");
	WriteDevice (cmdBuf);
	//printf ("%s \n", cmdBuf);
	ReadDevice(MDX_reg, 512);
	//printf ("%s \n", MDX_reg);

	sscanf(MDX_reg, "WORD,23100002,%x", &regVal); 		
	regVal1 = (regVal & 0x00FF); 
	regVal2 = (regVal & 0xFF00);	
	regVal2 >>= 8;
	
	// MDX channel 1 register 1
	SetCtrlVal(panel, MDX_BYTE0TO7OEN, regVal1);

	// MDX channel 2 register 0
	SetCtrlVal(panel, MDX_BYTE0TO7OEN_2, regVal2);
	
	return 0;

}

// This function is called when READ button is pressed in REGISTER 2    
int CVICALLBACK readReg2 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{    
    char cmdBuf[512], MDX_reg[512];
    unsigned int regVal;
    
    if (event != EVENT_COMMIT) 
   	return 0;              									   
	
	sprintf (cmdBuf, "$$HA_MEMORY? WORD, 23100004, 1");
	WriteDevice (cmdBuf);
	//printf ("%s \n", cmdBuf);
	ReadDevice(MDX_reg , 512);
	//printf ("%s \n", MDX_reg);

	sscanf(MDX_reg, "WORD,23100004,%x", &regVal); 		
	
	// MDX channel 1 register 0
	SetCtrlVal(panel, MDX_INVA, (regVal &0x0001) == 0x0001);
	SetCtrlVal(panel, MDX_INVB, (regVal &0x0002) == 0x0002);			
	SetCtrlVal(panel, MDX_FLIPA, (regVal &0x0004) == 0x0004);
	SetCtrlVal(panel, MDX_FLIPB, (regVal &0x0008) == 0x0008);
	SetCtrlVal(panel, MDX_BIN2GRAY, (regVal &0x0010) == 0x0010);
	SetCtrlVal(panel, MDX_GRAY2BIN, (regVal &0x0020) == 0x0020);
	SetCtrlVal(panel, MDX_REVBIT_0, (regVal &0x0040) == 0x0040);			   	   
	SetCtrlVal(panel, MDX_REVBIT_1, (regVal &0x0080) == 0x0080);

	// MDX channel 2 register 0
	SetCtrlVal(panel, MDX_INVA_2, (regVal &0x0100) == 0x0100);
	SetCtrlVal(panel, MDX_INVB_2, (regVal &0x0200) == 0x0200);			
	SetCtrlVal(panel, MDX_FLIPA_2, (regVal &0x0400) == 0x0400);
	SetCtrlVal(panel, MDX_FLIPB_2, (regVal &0x0800) == 0x0800);
	SetCtrlVal(panel, MDX_BIN2GRAY_2, (regVal &0x1000) == 0x1000);
	SetCtrlVal(panel, MDX_GRAY2BIN_2, (regVal &0x2000) == 0x2000);
	SetCtrlVal(panel, MDX_REVBIT_2_0, (regVal &0x4000) == 0x4000);			   	   
	SetCtrlVal(panel, MDX_REVBIT_2_1, (regVal &0x8000) == 0x8000);
	
	return 0;
}

// This function is called when READ button is pressed in REGISTER 3
int CVICALLBACK readReg3 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    char cmdBuf[512], MDX_reg[512];
    unsigned int regVal;
    
    if (event != EVENT_COMMIT) 
   	return 0;              									   
	
	sprintf (cmdBuf, "$$HA_MEMORY? WORD, 23100006, 1");
	WriteDevice (cmdBuf);
	//printf ("%s \n", cmdBuf);
	ReadDevice(MDX_reg, 512);
	//printf ("%s \n", MDX_reg);

	sscanf(MDX_reg, "WORD,23100006,%x", &regVal); 		
	
	// MDX channel 1 register 0
	SetCtrlVal(panel, MDX_INVMSB, (regVal &0x0001) == 0x0001);
	//SetCtrlVal(panel, MDX_INVB, (regVal &0x0002) == 0x0002);			
	SetCtrlVal(panel, MDX_MEMDELAY_0, (regVal &0x0004) == 0x0004);
	SetCtrlVal(panel, MDX_MEMDELAY_1, (regVal &0x0008) == 0x0008);
	SetCtrlVal(panel, MDX_ADRSDELAY_0, (regVal &0x0010) == 0x0010);
	SetCtrlVal(panel, MDX_ADRSDELAY_1, (regVal &0x0020) == 0x0020);
	SetCtrlVal(panel, MDX_ADRSDIV_0, (regVal &0x0040) == 0x0040);			   	   
	SetCtrlVal(panel, MDX_ADRSDIV_1, (regVal &0x0080) == 0x0080);

	// MDX channel 2 register 0
	SetCtrlVal(panel, MDX_INVMSB_2, (regVal &0x0100) == 0x0100);
	//SetCtrlVal(panel, MDX_INVB_2, (regVal &0x0200) == 0x0200);			
	SetCtrlVal(panel, MDX_MEMDELAY_2_0, (regVal &0x0400) == 0x0400);
	SetCtrlVal(panel, MDX_MEMDELAY_2_1, (regVal &0x0800) == 0x0800);
	SetCtrlVal(panel, MDX_ADRSDELAY_2_0, (regVal &0x1000) == 0x1000);
	SetCtrlVal(panel, MDX_ADRSDELAY_2_1, (regVal &0x2000) == 0x2000);
	SetCtrlVal(panel, MDX_ADRSDIV_2_0, (regVal &0x4000) == 0x4000);			   	   
	SetCtrlVal(panel, MDX_ADRSDIV_2_1, (regVal &0x8000) == 0x8000);
	
	return 0;
}

// This function is called when READ button is pressed in REGISTER 4
int CVICALLBACK readReg4 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    char cmdBuf[512], MDX_reg[512];
    unsigned int regVal, regVal1, regVal2;
    
    if (event != EVENT_COMMIT) 
   	return 0;              									   
	
	sprintf (cmdBuf, "$$HA_MEMORY? WORD, 23100008, 1");
	WriteDevice (cmdBuf);
	//printf ("%s \n", cmdBuf);
	ReadDevice(MDX_reg, 512); 
	//printf ("%s \n", MDX_reg);

	sscanf(MDX_reg, "WORD,23100008,%x", &regVal); 		
	regVal1 = (regVal & 0x00FF); 
	regVal2 = (regVal & 0xFF00);	
	regVal2 >>= 8;
	
	// MDX channel 1 register 1
	SetCtrlVal(panel, MDX_STARTADDRESS, regVal1);

	// MDX channel 2 register 0
	SetCtrlVal(panel, MDX_STARTADDRESS_2, regVal2);
	
	return 0;
}
