/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2001. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  CHANNEL                         1
#define  CHANNEL_TRACE_C4                2       /* callback function: SetTraceCallback */
#define  CHANNEL_TRACE_C3                3       /* callback function: SetTraceCallback */
#define  CHANNEL_TRACE_C2                4       /* callback function: SetTraceCallback */
#define  CHANNEL_COUPLING                5       /* callback function: SetChanCoupling */
#define  CHANNEL_TRACE_C1                6       /* callback function: SetTraceCallback */
#define  CHANNEL_VDIV                    7       /* callback function: SetVoltsPerDiv */
#define  CHANNEL_FIND_TRACE              8       /* callback function: FindGainOffset */
#define  CHANNEL_CHAN_OFFSET             9       /* callback function: SetChanOffset */
#define  CHANNEL_CHN_SEL_C4              10      /* callback function: SelectChannel */
#define  CHANNEL_CHN_SEL_C3              11      /* callback function: SelectChannel */
#define  CHANNEL_CHN_SEL_C2              12      /* callback function: SelectChannel */
#define  CHANNEL_CHN_SEL_C1              13      /* callback function: SelectChannel */
#define  CHANNEL_DECORATION_3            14
#define  CHANNEL_TEXTMSG_6               15
#define  CHANNEL_TEXTMSG_13              16
#define  CHANNEL_TEXTMSG_10              17

#define  COMMAND                         2
#define  COMMAND_COMMAND                 2       /* callback function: CommandCB */
#define  COMMAND_REPLY                   3
#define  COMMAND_CLEAR                   4       /* callback function: ClearResponseBox_CB */
#define  COMMAND_COMMANDBUTTON           5       /* callback function: RunAllCommands_CB */
#define  COMMAND_RUN_MSG                 6

#define  DATALOGGER                      3
#define  DATALOGGER_PATH                 2
#define  DATALOGGER_FILENAME             3
#define  DATALOGGER_INDEX                4
#define  DATALOGGER_LED                  5
#define  DATALOGGER_NO_OF_ACQUISITIONS   6       /* callback function: NoOfAcquisitions */
#define  DATALOGGER_STOP_DATALOGGER      7       /* callback function: StopDatalogger */
#define  DATALOGGER_START_ACQUISITION    8       /* callback function: StartAcquisition */
#define  DATALOGGER_DATALOGGER           9       /* callback function: Datalogger */
#define  DATALOGGER_TEXTBOX              10
#define  DATALOGGER_BROWSE_DIR           11      /* callback function: BrowseDir */
#define  DATALOGGER_DECORATION           12
#define  DATALOGGER_TEXTMSG_9            13

#define  MAINPANEL                       4
#define  MAINPANEL_SCREEN_2              2       /* callback function: DefaultCallback */
#define  MAINPANEL_SCREEN_1              3       /* callback function: DefaultCallback */
#define  MAINPANEL_TIME_DELAY_SLIDE      4       /* callback function: SetTrigDelay */
#define  MAINPANEL_LED                   5
#define  MAINPANEL_CANVAS                6
#define  MAINPANEL_VDIV_MSG_1            7
#define  MAINPANEL_TDIV_MSG_1            8
#define  MAINPANEL_TDIV_MSG_2            9
#define  MAINPANEL_VDIV_MSG_2            10
#define  MAINPANEL_TDIV_MSG_3            11
#define  MAINPANEL_VDIV_MSG_3            12
#define  MAINPANEL_TDIV_MSG_4            13
#define  MAINPANEL_VDIV_MSG_4            14
#define  MAINPANEL_BORDER_1              15
#define  MAINPANEL_BORDER_2              16
#define  MAINPANEL_BORDER_3              17
#define  MAINPANEL_BORDER_4              18
#define  MAINPANEL_SAMPLE_RATE_TEXT      19
#define  MAINPANEL_MEASURE_TEXT          20
#define  MAINPANEL_ERROR_MESSAGE         21
#define  MAINPANEL_TRMD_STATUS           22
#define  MAINPANEL_BOX_LABEL_1           23
#define  MAINPANEL_BOX_LABEL_2           24
#define  MAINPANEL_BOX_LABEL_3           25
#define  MAINPANEL_BOX_LABEL_4           26
#define  MAINPANEL_TIMER                 27
#define  MAINPANEL_TRG_LEVEL_TEXT        28
#define  MAINPANEL_UPDATE_RATE           29

#define  MATH                            5
#define  MATH_SELECT_TD                  2       /* callback function: SelectMathTrace */
#define  MATH_SELECT_TC                  3       /* callback function: SelectMathTrace */
#define  MATH_SELECT_TB                  4       /* callback function: SelectMathTrace */
#define  MATH_SELECT_TA                  5       /* callback function: SelectMathTrace */
#define  MATH_MATH_FUNCTION              6       /* callback function: SetMathFunction */
#define  MATH_TRACE_TD                   7       /* callback function: SetTraceCallback */
#define  MATH_VMAG_3                     8       /* callback function: SetVMAG */
#define  MATH_TRACE_TC                   9       /* callback function: SetTraceCallback */
#define  MATH_TRACE_TB                   10      /* callback function: SetTraceCallback */
#define  MATH_MAG_RESET                  11      /* callback function: ResetMath_CB */
#define  MATH_TRACE_TA                   12      /* callback function: SetTraceCallback */
#define  MATH_HMAG                       13      /* callback function: SetHMAG */
#define  MATH_ZOOM_POSITION              14      /* callback function: SetZoomPosition */
#define  MATH_ZOOM_OFFSET                15      /* callback function: SetZoomOffset */
#define  MATH_VMAG                       16      /* callback function: SetVMAG */
#define  MATH_TEXTMSG_11                 17
#define  MATH_DECORATION_4               18
#define  MATH_TEXTMSG_15                 19
#define  MATH_TEXTMSG_14                 20

#define  NEWCON                          6
#define  NEWCON_ADDRESS                  2       /* callback function: NewConn_CB */
#define  NEWCON_OK                       3       /* callback function: NewConn_CB */
#define  NEWCON_CANCEL                   4       /* callback function: NewConn_CB */
#define  NEWCON_CON_TYPE                 5

#define  TIMEBASE                        7
#define  TIMEBASE_TIME_DIV               2       /* callback function: SetTimePerDiv */
#define  TIMEBASE_TRMD_NORM              3       /* callback function: SetTriggerMode */
#define  TIMEBASE_TRMD_AUTO              4       /* callback function: SetTriggerMode */
#define  TIMEBASE_TRMD_STOP              5       /* callback function: SetTriggerMode */
#define  TIMEBASE_TIME_DELAY             6       /* callback function: SetTriggerDelay */
#define  TIMEBASE_SAMPLE_SIZE            7       /* callback function: SetSampleSize */
#define  TIMEBASE_TRMD_SNGL              8       /* callback function: SetTriggerMode */
#define  TIMEBASE_DECORATION             9
#define  TIMEBASE_TEXTMSG_9              10

#define  TRIGGER                         8
#define  TRIGGER_TYPE                    2       /* callback function: SetTriggerType */
#define  TRIGGER_LEVEL                   3       /* callback function: EnableTrigCursor */
#define  TRIGGER_SLOPE                   4       /* callback function: SetTriggerSlope */
#define  TRIGGER_SOURCE                  5       /* callback function: SetTriggerSource */
#define  TRIGGER_COUPLING                6       /* callback function: SetTrigCoupling */
#define  TRIGGER_GLITCH_AT_END_OF        7       /* callback function: SetTriggerSlope */
#define  TRIGGER_GLITCH_GET_S            8       /* callback function: SetGlitchTrigger */
#define  TRIGGER_GLITCH_SET_S            9       /* callback function: SetGlitchTrigger */
#define  TRIGGER_GLITCH_GET_V            10      /* callback function: SetGlitchTrigger */
#define  TRIGGER_GLITCH_SET_V            11      /* callback function: SetGlitchTrigger */
#define  TRIGGER_DECORATION              12
#define  TRIGGER_TEXTMSG_9               13

#define  UTILITY                         9
#define  UTILITY_GRID_CHECK              2       /* callback function: ShowGridCallback */
#define  UTILITY_MEAS_CURSOR             3       /* callback function: EnableMeasureCursor */
#define  UTILITY_PERSISTENCE             4       /* callback function: SetPersistence */
#define  UTILITY_DUAL_SCREEN             5       /* callback function: SetNumScreen */
#define  UTILITY_SCOPE_DISPLAY           6       /* callback function: ScopeDisplay */
#define  UTILITY_TEXTMSG_12              7
#define  UTILITY_DECORATION_2            8


     /* Menu Bars, Menus, and Menu Items: */

#define  MENUBAR                         1
#define  MENUBAR_FILE                    2
#define  MENUBAR_FILE_NEW_CONNECTION     3       /* callback function: FileMenuCallback */
#define  MENUBAR_FILE_SAVE_AS            4       /* callback function: FileMenuCallback */
#define  MENUBAR_FILE_SEPARATOR          5
#define  MENUBAR_FILE_SEPARATOR_2        6
#define  MENUBAR_FILE_EXIT               7       /* callback function: FileMenuCallback */
#define  MENUBAR_OPTION                  8
#define  MENUBAR_OPTION_RESYNC_PANEL     9       /* callback function: ResyncPanel_CB */
#define  MENUBAR_OPTION_CHANGE_COLOR     10      /* callback function: ChangeColor */
#define  MENUBAR_OPTION_RMT_SPY          11      /* callback function: CB_CommSpy */
#define  MENUBAR_HELP                    12
#define  MENUBAR_HELP_ABOUT              13      /* callback function: AboutCallback */


     /* Callback Prototypes: */ 

void CVICALLBACK AboutCallback(int menubar, int menuItem, void *callbackData, int panel);
int  CVICALLBACK BrowseDir(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
void CVICALLBACK CB_CommSpy(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK ChangeColor(int menubar, int menuItem, void *callbackData, int panel);
int  CVICALLBACK ClearResponseBox_CB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK CommandCB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Datalogger(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK DefaultCallback(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK EnableMeasureCursor(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK EnableTrigCursor(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
void CVICALLBACK FileMenuCallback(int menubar, int menuItem, void *callbackData, int panel);
int  CVICALLBACK FindGainOffset(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK NewConn_CB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK NoOfAcquisitions(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ResetMath_CB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
void CVICALLBACK ResyncPanel_CB(int menubar, int menuItem, void *callbackData, int panel);
int  CVICALLBACK RunAllCommands_CB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ScopeDisplay(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SelectChannel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SelectMathTrace(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetChanCoupling(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetChanOffset(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetGlitchTrigger(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetHMAG(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetMathFunction(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetNumScreen(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetPersistence(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetSampleSize(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetTimePerDiv(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetTraceCallback(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetTrigCoupling(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetTrigDelay(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetTriggerDelay(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetTriggerMode(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetTriggerSlope(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetTriggerSource(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetTriggerType(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetVMAG(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetVoltsPerDiv(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetZoomOffset(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetZoomPosition(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ShowGridCallback(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK StartAcquisition(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK StopDatalogger(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
