/*
 *			Remote LSA
 *
 *			Copyright (c) 1998 LeCroy Corporation
 *			
 *			Written By: Ricardo Palacio
 *
 *			April, 1998
 *
 *
 */


/* 
 * $Header: /Test Framework 3/LSA1000 GS/Net LSA/main.c 3     5/05/98 10:16a Ricardop $
 * $Log: /Test Framework 3/LSA1000 GS/Net LSA/main.c $
 * 
 * 3     5/05/98 10:16a Ricardop
 * Added some minor clean-up
 * 
 * 2     4/27/98 6:26p Ricardop
 * Changed the trace update from timer based to Main Loop.
 * 
 * 1     4/27/98 4:53p Ricardop
 * Initial check-in
 * 
 */

#include <winsock.h>
#include <easytab.h>
#include <ansi_c.h>
#include <utility.h>
#include <userint.h>
#include <toolbox.h>
#include <formatio.h>
#include <toolbox.h>



// LeCroy Libs.
#include <interface.h>
#include <dsopanel.h>
#include <global_info.h>
#include <update_panel.h>
#include <str_utils.h>
#include <update_struct.h>
#include <update_plot.h>



DSO_INFO		gDSO_Info;
PANEL_INFO		gPanel_Info;



static int InitializePanel(void)
{

	int i;

    // Info box controls
    gPanel_Info.Info_Box[TRACE_1].cxVDIV_Message = MAINPANEL_VDIV_MSG_1;
    gPanel_Info.Info_Box[TRACE_2].cxVDIV_Message = MAINPANEL_VDIV_MSG_2;
    gPanel_Info.Info_Box[TRACE_3].cxVDIV_Message = MAINPANEL_VDIV_MSG_3;
    gPanel_Info.Info_Box[TRACE_4].cxVDIV_Message = MAINPANEL_VDIV_MSG_4;
    gPanel_Info.Info_Box[TRACE_1].cxTDIV_Message = MAINPANEL_TDIV_MSG_1;
    gPanel_Info.Info_Box[TRACE_2].cxTDIV_Message = MAINPANEL_TDIV_MSG_2;
    gPanel_Info.Info_Box[TRACE_3].cxTDIV_Message = MAINPANEL_TDIV_MSG_3;
    gPanel_Info.Info_Box[TRACE_4].cxTDIV_Message = MAINPANEL_TDIV_MSG_4;
    gPanel_Info.Info_Box[TRACE_1].cxBorder = MAINPANEL_BORDER_1;
    gPanel_Info.Info_Box[TRACE_2].cxBorder = MAINPANEL_BORDER_2;
    gPanel_Info.Info_Box[TRACE_3].cxBorder = MAINPANEL_BORDER_3;
    gPanel_Info.Info_Box[TRACE_4].cxBorder = MAINPANEL_BORDER_4;
    gPanel_Info.Info_Box[TRACE_1].cxBox_Label = MAINPANEL_BOX_LABEL_1;
    gPanel_Info.Info_Box[TRACE_2].cxBox_Label = MAINPANEL_BOX_LABEL_2;
    gPanel_Info.Info_Box[TRACE_3].cxBox_Label = MAINPANEL_BOX_LABEL_3;
    gPanel_Info.Info_Box[TRACE_4].cxBox_Label = MAINPANEL_BOX_LABEL_4;
	
	// channel controls
    gPanel_Info.Channel_Controls.cxVDIV = CHANNEL_VDIV;
    gPanel_Info.Channel_Controls.cxCoupling = CHANNEL_COUPLING;
    gPanel_Info.Channel_Controls.cxOffset = CHANNEL_CHAN_OFFSET;
    gPanel_Info.Channel_Controls.cxFind = CHANNEL_FIND_TRACE;
    gPanel_Info.Channel_Controls.cxChan_ON_OFF[CHANNEL_1] = CHANNEL_TRACE_C1;
    gPanel_Info.Channel_Controls.cxChan_ON_OFF[CHANNEL_2] = CHANNEL_TRACE_C2;
    gPanel_Info.Channel_Controls.cxChan_ON_OFF[CHANNEL_3] = CHANNEL_TRACE_C3;
    gPanel_Info.Channel_Controls.cxChan_ON_OFF[CHANNEL_4] = CHANNEL_TRACE_C4;
    gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_1] = CHANNEL_CHN_SEL_C1;
    gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_2] = CHANNEL_CHN_SEL_C2;
    gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_3] = CHANNEL_CHN_SEL_C3;
    gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_4] = CHANNEL_CHN_SEL_C4;
    
    // timebase controls
    gPanel_Info.Timebase_Controls.cxTDIV = TIMEBASE_TIME_DIV;
    gPanel_Info.Timebase_Controls.cxDelay = TIMEBASE_TIME_DELAY;
    gPanel_Info.Timebase_Controls.cxDelay_Slide = MAINPANEL_TIME_DELAY_SLIDE;
    gPanel_Info.Timebase_Controls.cxStop = TIMEBASE_TRMD_STOP;
    gPanel_Info.Timebase_Controls.cxAuto = TIMEBASE_TRMD_AUTO;
    gPanel_Info.Timebase_Controls.cxNorm = TIMEBASE_TRMD_NORM;
    gPanel_Info.Timebase_Controls.cxSngl = TIMEBASE_TRMD_SNGL;
    gPanel_Info.Timebase_Controls.cxSample_Size = TIMEBASE_SAMPLE_SIZE;
    
    // trigger controls
    gPanel_Info.Trigger_Controls.cxType = TRIGGER_TYPE;
    gPanel_Info.Trigger_Controls.cxSource = TRIGGER_SOURCE;
    gPanel_Info.Trigger_Controls.cxSlope = TRIGGER_SLOPE;
    gPanel_Info.Trigger_Controls.cxCoupling = TRIGGER_COUPLING;
    gPanel_Info.Trigger_Controls.cxGlitch_At_End_Of = TRIGGER_GLITCH_AT_END_OF;
    gPanel_Info.Trigger_Controls.cxGlitch_Smaller_Equal_Than_Switch = TRIGGER_GLITCH_SET_S;
    gPanel_Info.Trigger_Controls.cxGlitch_Smaller_Equal_Than_Value = TRIGGER_GLITCH_SET_V;
    gPanel_Info.Trigger_Controls.cxGlitch_Greater_Equal_Than_Switch = TRIGGER_GLITCH_GET_S;
    gPanel_Info.Trigger_Controls.cxGlitch_Greater_Equal_Than_Value = TRIGGER_GLITCH_GET_V;
    

    
    // display + utility controls
    gPanel_Info.Utility_Controls.cxGrid_Enable = UTILITY_GRID_CHECK;
    gPanel_Info.Utility_Controls.cxMeasure_Cursor = UTILITY_MEAS_CURSOR;
    gPanel_Info.Utility_Controls.cxPersistence = UTILITY_PERSISTENCE;
    gPanel_Info.Utility_Controls.cxDual_Screen = UTILITY_DUAL_SCREEN;
    gPanel_Info.Utility_Controls.cxScope_Display = UTILITY_SCOPE_DISPLAY;
    
    
    // Zoom + math controls
    gPanel_Info.Zoom_Math_Controls.cxTrace[TRACE_1] = MATH_TRACE_TA;
    gPanel_Info.Zoom_Math_Controls.cxTrace[TRACE_2] = MATH_TRACE_TB;
    gPanel_Info.Zoom_Math_Controls.cxTrace[TRACE_3] = MATH_TRACE_TC;
    gPanel_Info.Zoom_Math_Controls.cxTrace[TRACE_4] = MATH_TRACE_TD;
    gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_1] = MATH_SELECT_TA;
    gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_2] = MATH_SELECT_TB;
    gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_3] = MATH_SELECT_TC;
    gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_4] = MATH_SELECT_TD;
    gPanel_Info.Zoom_Math_Controls.cxOffset = MATH_ZOOM_OFFSET;
    gPanel_Info.Zoom_Math_Controls.cxPosition = MATH_ZOOM_POSITION;
    gPanel_Info.Zoom_Math_Controls.cxFunction_Button = MATH_MATH_FUNCTION;
    gPanel_Info.Zoom_Math_Controls.cxVMAG = MATH_VMAG;
    gPanel_Info.Zoom_Math_Controls.cxHMAG = MATH_HMAG;
    gPanel_Info.Zoom_Math_Controls.cxMAG_Reset = MATH_MAG_RESET;

    // Datalogger controls
    gPanel_Info.Datalogger_Controls.cxPath = DATALOGGER_PATH;
    gPanel_Info.Datalogger_Controls.cxFilename = DATALOGGER_FILENAME;
    gPanel_Info.Datalogger_Controls.cxIndex = DATALOGGER_INDEX;
    gPanel_Info.Datalogger_Controls.cxNo_Of_Acquisitions = DATALOGGER_NO_OF_ACQUISITIONS;
    gPanel_Info.Datalogger_Controls.cxStop = DATALOGGER_STOP_DATALOGGER;
    gPanel_Info.Datalogger_Controls.cxStart_Acquisition = DATALOGGER_START_ACQUISITION;
    gPanel_Info.Datalogger_Controls.cxDatalogger = DATALOGGER_DATALOGGER;
    
    
    
    // Misc. controls
    gPanel_Info.Misc_Controls.cxMeasure_Text = MAINPANEL_MEASURE_TEXT;
    gPanel_Info.Misc_Controls.cxTrig_Mode_Text = MAINPANEL_TRMD_STATUS;
    gPanel_Info.Misc_Controls.cxUpdate_Rate_Text = MAINPANEL_UPDATE_RATE;
    gPanel_Info.Misc_Controls.cxCommand_Box = COMMAND_COMMAND;
    gPanel_Info.Misc_Controls.cxReply_Box =  COMMAND_REPLY;
    gPanel_Info.Misc_Controls.cxRun_Message = COMMAND_RUN_MSG;
    gPanel_Info.Misc_Controls.cxSample_Rate_Text = MAINPANEL_SAMPLE_RATE_TEXT;
    gPanel_Info.Misc_Controls.cxTrg_Level_Text = MAINPANEL_TRG_LEVEL_TEXT;
    gPanel_Info.Misc_Controls.cxError_Message = MAINPANEL_ERROR_MESSAGE;
    
    
    // graph controls
    gPanel_Info.cxScreen1 = MAINPANEL_SCREEN_1;
    gPanel_Info.cxScreen2 = MAINPANEL_SCREEN_2;
    gPanel_Info.cxActive_Cursor = NO_VALUE;
    gPanel_Info.cxActive_Cursor_Panel = NO_VALUE;
    
    gDSO_Info.iSelected_Channel = TRACE_ID_C1;
    gDSO_Info.iSelected_Math_Trace = TRACE_ID_TA;
    
    /* load user interface panel */
    gPanel_Info.hNewConnection = LoadPanel(0, "dsopanel.uir", NEWCON);
    gPanel_Info.hMainPanel = LoadPanel(0, "dsopanel.uir", MAINPANEL);
    gPanel_Info.hTimebasePanel = LoadPanel(gPanel_Info.hMainPanel, "dsopanel.uir", TIMEBASE);
    gPanel_Info.hTriggerPanel = LoadPanel(gPanel_Info.hMainPanel, "dsopanel.uir", TRIGGER);
    gPanel_Info.hChannelPanel = LoadPanel(gPanel_Info.hMainPanel, "dsopanel.uir", CHANNEL);
    gPanel_Info.hMathPanel = LoadPanel(gPanel_Info.hMainPanel, "dsopanel.uir", MATH);
    gPanel_Info.hUtilityPanel = LoadPanel(gPanel_Info.hMainPanel, "dsopanel.uir", UTILITY);
    gPanel_Info.hCommandPanel = LoadPanel(gPanel_Info.hMainPanel, "dsopanel.uir", COMMAND);
    gPanel_Info.hDataloggerPanel = LoadPanel(gPanel_Info.hMainPanel, "dsopanel.uir", DATALOGGER);
    
	
	gPanel_Info.hTabControl = EasyTab_Create (gPanel_Info.hMainPanel, 32, 570, 0, 0);
	
	EasyTab_AddPanels (gPanel_Info.hMainPanel, gPanel_Info.hTabControl, 1, gPanel_Info.hTimebasePanel,
						gPanel_Info.hChannelPanel, gPanel_Info.hTriggerPanel,gPanel_Info.hDataloggerPanel, 0);
	
	EasyTab_AddPanels (gPanel_Info.hMainPanel, gPanel_Info.hTabControl, 2, gPanel_Info.hMathPanel, 
						gPanel_Info.hUtilityPanel, gPanel_Info.hCommandPanel, 0);
	
	EasyTab_SetAttribute (gPanel_Info.hMainPanel, gPanel_Info.hTabControl, ATTR_EASY_TAB_ORIENTATION,
                      	VAL_EASY_TAB_BTNS_ON_BOTTOM);
	
	EasyTab_SetAttribute (gPanel_Info.hMainPanel, gPanel_Info.hTabControl, ATTR_EASY_TAB_LABEL_COLOR, VAL_BLUE);
	
	EasyTab_SetAttribute (gPanel_Info.hMainPanel, gPanel_Info.hTabControl, ATTR_EASY_TAB_STRETCH_TO_FIT, TRUE);

	EasyTab_AutoSize (gPanel_Info.hMainPanel, gPanel_Info.hTabControl);
	
//	EasyTab_SetAttribute (gPanel_Info.hMainPanel, gPanel_Info.hTabControl, ATTR_EASY_TAB_ACTIVE_PANEL, 
//							gPanel_Info.hChannelPanel);
	
	
	SetSleepPolicy (VAL_SLEEP_MORE);
	DisplayPanel(gPanel_Info.hMainPanel);
	mSetRunMessage(FALSE);
	
	// set the number of screens
	gDSO_Info.iNum_Screen = 1;
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.cxScreen2, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute (gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, ATTR_HEIGHT, 398);
	
    // set default trace colors
    gDSO_Info.Trace[TRACE_1].ulTrace_Color = TRACE_1_COLOR;
    gDSO_Info.Trace[TRACE_2].ulTrace_Color = TRACE_2_COLOR;
    gDSO_Info.Trace[TRACE_3].ulTrace_Color = TRACE_3_COLOR;
    gDSO_Info.Trace[TRACE_4].ulTrace_Color = TRACE_4_COLOR;
    gDSO_Info.Trace[TRACE_5].ulTrace_Color = TRACE_5_COLOR;
    gDSO_Info.Trace[TRACE_6].ulTrace_Color = TRACE_6_COLOR;
    gDSO_Info.Trace[TRACE_7].ulTrace_Color = TRACE_7_COLOR;
    gDSO_Info.Trace[TRACE_8].ulTrace_Color = TRACE_8_COLOR;

	// init trace buffers
	for (i=TRACE_1; i<=TRACE_8; i++) 
	{
		gDSO_Info.Trace[i].bTrace_ON = FALSE;
		gDSO_Info.Trace[i].ptrRawData = NULL;
		gDSO_Info.Trace[i].ulTrace_Size = 0;
	}
	
	// set trace ID
	gDSO_Info.Trace[TRACE_1].Trace_ID = TRACE_ID_C1;
	gDSO_Info.Trace[TRACE_2].Trace_ID = TRACE_ID_C2;
	gDSO_Info.Trace[TRACE_3].Trace_ID = TRACE_ID_C3;
	gDSO_Info.Trace[TRACE_4].Trace_ID = TRACE_ID_C4;
	gDSO_Info.Trace[TRACE_5].Trace_ID = TRACE_ID_TA;
	gDSO_Info.Trace[TRACE_6].Trace_ID = TRACE_ID_TB;
	gDSO_Info.Trace[TRACE_7].Trace_ID = TRACE_ID_TC;
	gDSO_Info.Trace[TRACE_8].Trace_ID = TRACE_ID_TD;
	

	// set trig ID
	gDSO_Info.Trig[TRIG_1].Trig_ID = TRIG_ID_C1;
	gDSO_Info.Trig[TRIG_2].Trig_ID = TRIG_ID_C2;
	gDSO_Info.Trig[TRIG_3].Trig_ID = TRIG_ID_C3;
	gDSO_Info.Trig[TRIG_4].Trig_ID = TRIG_ID_C4;
	gDSO_Info.Trig[TRIG_5].Trig_ID = TRIG_ID_EXT;
	gDSO_Info.Trig[TRIG_6].Trig_ID = TRIG_ID_EXT10;
	gDSO_Info.Trig[TRIG_7].Trig_ID = TRIG_ID_LINE;


	// Set Trig types
/*	
	gDSO_Info.Trig[TRIG_1].Trig_Type = TRIG_TYPE_EDGE;
	gDSO_Info.Trig[TRIG_2].Trig_Type = TRIG_TYPE_GLITCH;
	gDSO_Info.Trig[TRIG_3].Trig_Type = TRIG_TYPE_INTERVAL;
	gDSO_Info.Trig[TRIG_4].Trig_Type = TRIG_TYPE_TV;
	gDSO_Info.Trig[TRIG_5].Trig_Type = TRIG_TYPE_QUALIFIED;
	gDSO_Info.Trig[TRIG_7].Trig_Type = TRIG_TYPE_DROPOUT;
	gDSO_Info.Trig[TRIG_7].Trig_Type = TRIG_TYPE_PATTERN;
*/
	
	// info box index
	gDSO_Info.Trace[TRACE_1].iInfoBox_Index = NO_VALUE;
	gDSO_Info.Trace[TRACE_2].iInfoBox_Index = NO_VALUE;
	gDSO_Info.Trace[TRACE_3].iInfoBox_Index = NO_VALUE;
	gDSO_Info.Trace[TRACE_4].iInfoBox_Index = NO_VALUE;
	gDSO_Info.Trace[TRACE_5].iInfoBox_Index = NO_VALUE;
	gDSO_Info.Trace[TRACE_6].iInfoBox_Index = NO_VALUE;
	gDSO_Info.Trace[TRACE_7].iInfoBox_Index = NO_VALUE;
	gDSO_Info.Trace[TRACE_8].iInfoBox_Index = NO_VALUE;
	
	
	// Set Trace names
	strcpy(gDSO_Info.Trace[TRACE_1].szTrace_Name, "C1");
	strcpy(gDSO_Info.Trace[TRACE_2].szTrace_Name, "C2");
	strcpy(gDSO_Info.Trace[TRACE_3].szTrace_Name, "C3");
	strcpy(gDSO_Info.Trace[TRACE_4].szTrace_Name, "C4");
	strcpy(gDSO_Info.Trace[TRACE_5].szTrace_Name, "TA");
	strcpy(gDSO_Info.Trace[TRACE_6].szTrace_Name, "TB");
	strcpy(gDSO_Info.Trace[TRACE_7].szTrace_Name, "TC");
	strcpy(gDSO_Info.Trace[TRACE_8].szTrace_Name, "TD");


	// Set Trig names
	strcpy(gDSO_Info.Trig[TRIG_1].szTrig_Source, "C1");
	strcpy(gDSO_Info.Trig[TRIG_2].szTrig_Source, "C2");
	strcpy(gDSO_Info.Trig[TRIG_3].szTrig_Source, "C3");
	strcpy(gDSO_Info.Trig[TRIG_4].szTrig_Source, "C4");
	strcpy(gDSO_Info.Trig[TRIG_5].szTrig_Source, "EXT");
	strcpy(gDSO_Info.Trig[TRIG_6].szTrig_Source, "EXT10");
	strcpy(gDSO_Info.Trig[TRIG_7].szTrig_Source, "LINE");
	
	// Set Trig types
	strcpy(gDSO_Info.Trig[TRIG_1].szTrig_Type, "EDGE");
	strcpy(gDSO_Info.Trig[TRIG_2].szTrig_Type, "GLIT");
	strcpy(gDSO_Info.Trig[TRIG_3].szTrig_Type, "INTV");
	strcpy(gDSO_Info.Trig[TRIG_4].szTrig_Type, "TVP");
	strcpy(gDSO_Info.Trig[TRIG_5].szTrig_Type, "TVN");
	strcpy(gDSO_Info.Trig[TRIG_6].szTrig_Type, "SQ");
	strcpy(gDSO_Info.Trig[TRIG_7].szTrig_Type, "DROP");
	
	
	// Set Trig holdoff types
	strcpy(gDSO_Info.Trig[TRIG_1].szTrig_Holdoff_Type, "OFF");			// no holdoff type
	strcpy(gDSO_Info.Trig[TRIG_2].szTrig_Holdoff_Type, "TI");			// holdoff in time
	strcpy(gDSO_Info.Trig[TRIG_3].szTrig_Holdoff_Type, "EV");			// holdoff in events
	
	// Set Trig Glitch pulse types
	strcpy(gDSO_Info.Trig[TRIG_1].szTrig_Glitch_Pulse_Type, "OFF");		// no limits set
	strcpy(gDSO_Info.Trig[TRIG_2].szTrig_Glitch_Pulse_Type, "PS");		// pulse smaller
	strcpy(gDSO_Info.Trig[TRIG_3].szTrig_Glitch_Pulse_Type, "PL");		// pulse larger
	strcpy(gDSO_Info.Trig[TRIG_4].szTrig_Glitch_Pulse_Type, "P2");		// pulse width window
	
	

	

	//measure cursor is off
	gDSO_Info.bMeasureCursorOn = FALSE;
	
	// hide the info box
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_1].cxBorder, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_1].cxVDIV_Message, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_1].cxTDIV_Message, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_1].cxBox_Label, ATTR_VISIBLE, FALSE);
	
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_2].cxBorder, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_2].cxVDIV_Message, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_2].cxTDIV_Message, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_2].cxBox_Label, ATTR_VISIBLE, FALSE);
	
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_3].cxBorder, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_3].cxVDIV_Message, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_3].cxTDIV_Message, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_3].cxBox_Label, ATTR_VISIBLE, FALSE);
	
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_4].cxBorder, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_4].cxVDIV_Message, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_4].cxTDIV_Message, ATTR_VISIBLE, FALSE);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.Info_Box[TRACE_4].cxBox_Label, ATTR_VISIBLE, FALSE);
	
	
	for (i=TRACE_1; i<MAX_TRACE_DISPLAYED; i++) 
	{
		gPanel_Info.Info_Box[i].bDisplayed = FALSE;
	}
	
    // set justification
	SetCtrlAttribute (gPanel_Info.hMainPanel, gPanel_Info.Misc_Controls.cxTrg_Level_Text, 
													ATTR_TEXT_JUSTIFY, VAL_LEFT_JUSTIFIED);
	SetCtrlAttribute (gPanel_Info.hMainPanel, gPanel_Info.Misc_Controls.cxUpdate_Rate_Text, 
													ATTR_TEXT_JUSTIFY, VAL_LEFT_JUSTIFIED);
	SetCtrlAttribute (gPanel_Info.hMainPanel, gPanel_Info.Misc_Controls.cxMeasure_Text, 
													ATTR_TEXT_JUSTIFY, VAL_LEFT_JUSTIFIED);
	SetCtrlAttribute (gPanel_Info.hMainPanel, gPanel_Info.Misc_Controls.cxError_Message, 
													ATTR_TEXT_JUSTIFY, VAL_LEFT_JUSTIFIED);

	// set screen refresh to manual
	// note: the plot in the UIR file should be set to copy and retain the data
	SetCtrlAttribute (gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, ATTR_REFRESH_GRAPH, FALSE);
	SetCtrlAttribute (gPanel_Info.hMainPanel, gPanel_Info.cxScreen2, ATTR_REFRESH_GRAPH, FALSE);
	
	// update the colors for the chan select buttons
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_1],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_1].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_2],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_2].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_3],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_3].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_4],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_4].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_1],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_1].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_2],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_2].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_3],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_3].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_4],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_4].ulTrace_Color);
	
	// update the colors for the math/zoom select buttons
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_1],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_5].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_2],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_6].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_3],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_7].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_4],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_8].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_1],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_5].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_2],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_6].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_3],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_7].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_4],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_8].ulTrace_Color);
	
	// set screen offsets to zero
	gDSO_Info.Trace[TRACE_1].dZoom_Offset = 0.0;
	gDSO_Info.Trace[TRACE_2].dZoom_Offset = 0.0;
	gDSO_Info.Trace[TRACE_3].dZoom_Offset = 0.0;
	gDSO_Info.Trace[TRACE_4].dZoom_Offset = 0.0;
	gDSO_Info.Trace[TRACE_5].dZoom_Offset = 0.0;
	gDSO_Info.Trace[TRACE_6].dZoom_Offset = 0.0;
	gDSO_Info.Trace[TRACE_7].dZoom_Offset = 0.0;
	gDSO_Info.Trace[TRACE_8].dZoom_Offset = 0.0;
	
	
	return 0;
}



static int MainCallback(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
    
    switch (event) 
    {
    	case EVENT_IDLE:
    		ProcessSystemEvents();
    		UpdateTrace();
    		break;
    	case EVENT_CLOSE:
    	case EVENT_END_TASK:
    		QuitUserInterface(0);
    		break;
    }

    return 0;
}







int CleanUp(void)
{
	int i;
	
	
	IM_WriteDevice("DISP ON");
	IM_Disconnect();
	
	DiscardPanel(gPanel_Info.hNewConnection);
	DiscardPanel(gPanel_Info.hTimebasePanel);
	DiscardPanel(gPanel_Info.hTriggerPanel);
	DiscardPanel(gPanel_Info.hChannelPanel);
	DiscardPanel(gPanel_Info.hMathPanel);
	DiscardPanel(gPanel_Info.hUtilityPanel);
	DiscardPanel(gPanel_Info.hCommandPanel);
	DiscardPanel(gPanel_Info.hDataloggerPanel);
	DiscardPanel(gPanel_Info.hMainPanel);

	if (gDSO_Info.ptrReadBuffer)
		free(gDSO_Info.ptrReadBuffer);
	
	for (i=TRACE_1; i<=TRACE_8; i++) 
		if (gDSO_Info.Trace[i].ptrRawData)
			free(gDSO_Info.Trace[i].ptrRawData);
	
	return 0;
}



int main (int argc, char *argv[])
{
    
	char strAddr[512], tmpStr[512];
	int manual = TRUE;
	int error;
	
	
    if (InitCVIRTE (0, argv, 0) == 0)    /* Needed if linking in external compiler; harmless otherwise */
        return -1;    /* out of memory */
    
	
	SuspendTimerCallbacks ();
	
	
	if (argc > 1)
	{
		if (strlen(argv[1]) > 5)
		{
			strcpy(strAddr, argv[1]);
			manual = FALSE;
		}
		if (strstr(argv[1], "tools"))
			gDSO_Info.bToolsEnabled = TRUE;
		else if (argc > 2)
			gDSO_Info.bToolsEnabled = TRUE;
		else
			gDSO_Info.bToolsEnabled = FALSE;
	}
	
	

	if (InitializePanel() < 0)
	{
		MessagePopup("ERROR", "Unable to initialize.\n");
		return -1;
	}

	
	if (manual)
	{
			error = OpenNewConnection();
	}
	else
	{
		StringUpperCase (strAddr);
		error = IM_MakeConnection(strAddr);
	}
	
	if (!error)
	{
		InitGlobalInfo();
		if (!manual)
		{
			sprintf(tmpStr, "Remote LSA - %s", strAddr);
			SetPanelAttribute (gPanel_Info.hMainPanel, ATTR_TITLE, tmpStr);
		}
	}
	else
	{
		sprintf(tmpStr, "Remote LSA - %s", "No connection established.");
		SetPanelAttribute (gPanel_Info.hMainPanel, ATTR_TITLE, tmpStr);
	}


	
	SetSleepPolicy(VAL_SLEEP_MORE);
	SetIdleEventRate (50);
	
	
	SetCtrlVal(gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_ON_OFF[CHANNEL_1], TRUE);
	SetCtrlVal(gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_ON_OFF[CHANNEL_2], TRUE);
	SetTraceVisibility(gPanel_Info.Channel_Controls.cxChan_ON_OFF[CHANNEL_1], TRUE);
	IM_WriteDevice("C1:TRA ON");
	SetTraceVisibility(gPanel_Info.Channel_Controls.cxChan_ON_OFF[CHANNEL_2], TRUE);
	IM_WriteDevice("C2:TRA ON");

	
	//main loop
	InstallMainCallback (MainCallback, NULL, 1);
	
	
	RunUserInterface ();
	
	CleanUp();
	
    return 0;

}


