/*
 *			Remote LSA
 *
 *			Copyright (c) 1998 LeCroy Corporation
 *			
 *			Written By: Ricardo Palacio
 *
 *			April, 1998
 *
 *
 */


/* 
 * $Header: /Test Framework 3/LSA1000 GS/Net LSA/menu_cb.c 1     4/27/98 4:53p Ricardop $
 * $Log: /Test Framework 3/LSA1000 GS/Net LSA/menu_cb.c $
 * 
 * 1     4/27/98 4:53p Ricardop
 * Initial check-in
 * 
 */

#include <ansi_c.h>
#include <utility.h>
#include <userint.h>
#include <toolbox.h>
#include <analysis.h>
#include <formatio.h>
#include <toolbox.h>


// LeCroy Libs.
#include <dsopanel.h>
#include <global_info.h>
#include <update_panel.h>
#include <interface.h>
#include <update_struct.h>




#define VERSION_NUMBER 			"PUTVERSIONHERE\0----------------------extra space--------------------------"




static ULONG def_color[] = {TRACE_1_COLOR, TRACE_2_COLOR, TRACE_3_COLOR, TRACE_4_COLOR, 
							TRACE_5_COLOR, TRACE_6_COLOR, TRACE_7_COLOR, TRACE_8_COLOR};

void CVICALLBACK ChangeColor (int menuBar, int menuItem, void *callbackData, int panel)
{


	ColorChangeEntry ColorEntry;
	ListType ColorList = 0;
	int result, i, len;
	unsigned long screen_color, grid_color, border_color;

	ColorList = ListCreate(sizeof(ColorChangeEntry));

	
	// create a list of colors
	for (i=TRACE_1; i<MAX_TRACE_COUNT; i++) 
	{
		ColorEntry.name = gDSO_Info.Trace[i].szTrace_Name;
		ColorEntry.color = gDSO_Info.Trace[i].ulTrace_Color;
		ColorEntry.defaultColor = def_color[i-1];
		ListInsertItem(ColorList, &ColorEntry, END_OF_LIST);
	}
	GetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, ATTR_PLOT_BGCOLOR, &screen_color);
	GetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, ATTR_GRID_COLOR, &grid_color);
	GetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, ATTR_GRAPH_BGCOLOR, &border_color);
	
	ColorEntry.name = "Screen Color";
	ColorEntry.color = screen_color;
	ColorEntry.defaultColor = screen_color;
	ListInsertItem(ColorList, &ColorEntry, END_OF_LIST);
	
	ColorEntry.name = "Grid Color";
	ColorEntry.color = grid_color;
	ColorEntry.defaultColor = grid_color;
	ListInsertItem(ColorList, &ColorEntry, END_OF_LIST);
	
	ColorEntry.name = "Plor Border Color";
	ColorEntry.color = border_color;
	ColorEntry.defaultColor = border_color;
	ListInsertItem(ColorList, &ColorEntry, END_OF_LIST);
	

	// show the color table
	result = ColorChangePopup("Select Colors", ColorList, 1, 0, 0);
	
	// update the trace colors
	if (result > 0) 
	{
		len = ListNumItems (ColorList);
		for (i=TRACE_1; i<MAX_TRACE_COUNT; i++) 
		{
			ListGetItem (ColorList, &ColorEntry, i);
			gDSO_Info.Trace[i].ulTrace_Color = ColorEntry.color;
		}
	}
	// get the color from the list
	ListGetItem (ColorList, &ColorEntry, MAX_TRACE_COUNT);
	screen_color = ColorEntry.color;
	ListGetItem (ColorList, &ColorEntry, MAX_TRACE_COUNT+1);
	grid_color = ColorEntry.color;
	ListGetItem (ColorList, &ColorEntry, MAX_TRACE_COUNT+2);
	border_color = ColorEntry.color;
	
	// update the screen color
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, ATTR_PLOT_BGCOLOR, screen_color);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, ATTR_GRAPH_BGCOLOR, border_color);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, ATTR_GRID_COLOR, grid_color);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.cxScreen2, ATTR_PLOT_BGCOLOR, screen_color);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.cxScreen2, ATTR_GRAPH_BGCOLOR, border_color);
	SetCtrlAttribute(gPanel_Info.hMainPanel, gPanel_Info.cxScreen2, ATTR_GRID_COLOR, grid_color);
	
	// update the trace info box
	for (i=TRACE_1; i<MAX_TRACE_COUNT; i++) 
	{
		UpdateInfoBox(&gDSO_Info, i);
	}
	
	// update the colors for the chan select buttons
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_1],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_1].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_2],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_2].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_3],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_3].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_4],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_4].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_1],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_1].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_2],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_2].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_3],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_3].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hChannelPanel, gPanel_Info.Channel_Controls.cxChan_Select[CHANNEL_4],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_4].ulTrace_Color);
	
	// update the colors for the math/zoom select buttons
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_1],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_5].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_2],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_6].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_3],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_7].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_4],
                  		ATTR_OFF_COLOR, gDSO_Info.Trace[TRACE_8].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_1],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_5].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_2],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_6].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_3],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_7].ulTrace_Color);
	SetCtrlAttribute (gPanel_Info.hMathPanel, gPanel_Info.Zoom_Math_Controls.cxTrace_Select[TRACE_4],
                  		ATTR_ON_COLOR, gDSO_Info.Trace[TRACE_8].ulTrace_Color);
	
	
	ListDispose(ColorList);


}



void CVICALLBACK AboutCallback (int menuBar, int menuItem, void *callbackData, int panel)
{

	char tmpStr[512];
	
	
	strcpy(tmpStr, "\"Remote LSA\"\n"
					"Copyright (c) 1998 LeCroy Corporation\n"
					"Written by: Ricardo Palacio\n\n"
					"Version ");
	strcat(tmpStr, VERSION_NUMBER);
	
	MessagePopup("About", tmpStr);
	


}




void CVICALLBACK FileMenuCallback (int menuBar, int menuItem, void *callbackData, int panel)
{
	char tmpStr[256];
	int ival;
	int error;
	
	
	switch (menuItem)
	{
		case MENUBAR_FILE_NEW_CONNECTION:
			error = OpenNewConnection();
			if (!error)
				InitGlobalInfo();
			break;
		case MENUBAR_FILE_SAVE_AS:
			break;
		case MENUBAR_FILE_EXIT:
			QuitUserInterface(1);
			break;
	}

}


void CVICALLBACK CB_CommSpy (int menuBar, int menuItem, void *callbackData, int panel)
{
	int checked;
	
	GetMenuBarAttribute (menuBar, menuItem, ATTR_CHECKED, &checked);
	if (checked)
	{
		IM_SetSpy(FALSE);
		SetMenuBarAttribute (menuBar, menuItem, ATTR_CHECKED, FALSE);
		SetStdioWindowVisibility (FALSE);
	}
	else
	{
		Cls();
		IM_SetSpy(TRUE);
		SetMenuBarAttribute (menuBar, menuItem, ATTR_CHECKED, TRUE);
		SetStdioWindowVisibility (TRUE);
	}
	
}


void CVICALLBACK ResyncPanel_CB (int menuBar, int menuItem, void *callbackData, int panel)
{
	InitGlobalInfo();
}
