/*
 *			Remote LSA
 *
 *			Copyright (c) 1998 LeCroy Corporation
 *			
 *			Written By: Ricardo Palacio
 *
 *			April, 1998
 *
 *
 */



/* 
 * $Header: /Test Framework 3/LSA1000 GS/Net LSA/update_plot.c 1     4/27/98 4:53p Ricardop $
 * $Log: /Test Framework 3/LSA1000 GS/Net LSA/update_plot.c $
 *
 * 2     9/30/01 PW
 * 
 * if (IM_QueryDevice(tmpStr, trace_info->ptrRawData, trace_info->ulTrace_Size + 256) < 0)
 * modified in GetWaveform to 
 * if (IM_QueryDevice(tmpStr, trace_info->ptrRawData, trace_info->ulTrace_Size + 256+346+4) < 0)
 * -> Datalogger

	sprintf(tmpStr, "%s:WF? DAT1", trace_info->szTrace_Name);
	to
 	sprintf(tmpStr, "%s:WF? ALL", trace_info->szTrace_Name);

 
 *  trace_info->ptrRawData = (char *) malloc(trace_info->ulTrace_Size + 256);
	to
	trace_info->ptrRawData = (char *) malloc(trace_info->ulTrace_Size + 256+346+4);


	if (IM_WriteDevice("CFMT OFF,BYTE,BIN") < 0)
	to
	if (IM_WriteDevice("CFMT DEF9,BYTE,BIN") < 0)

 *
 * 
 * 1     4/27/98 4:53p Ricardop
 * Initial check-in
 * 
 */

#include <ansi_c.h>
#include <utility.h>
#include <userint.h>
#include <toolbox.h>
#include <analysis.h>
#include <formatio.h>
#include <toolbox.h>



// LeCroy Libs.
#include <interface.h>
#include <global_info.h>
#include <update_panel.h>
#include <update_struct.h>
#include <dsopanel.h>

			





static int GetWaveform(TRACE_INFO *trace_info)
{

	char *idxPtr, tmpStr[512], rspStr[512];

	
	if (trace_info->ptrRawData)
	{
		free(trace_info->ptrRawData);
		trace_info->ptrRawData = NULL;
		trace_info->ulTrace_Size = 0;
	}
	
	
	//get the trace size
	sprintf(tmpStr, "%s:INSP? 'PNTS_PER_SCREEN'", trace_info->szTrace_Name);
	if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
		return -1;
	
	idxPtr = strchr(rspStr, ':');
	if (!idxPtr)
		return -1;
	
	sscanf(idxPtr+1, "%d", &trace_info->ulTrace_Size);
	
	
	// plus extra space
	trace_info->ptrRawData = (char *) malloc(trace_info->ulTrace_Size + 256+346+4);
	if (!trace_info->ptrRawData)
	{
		trace_info->ulTrace_Size = 0;
		return -1;
	}
	
	if (IM_WriteDevice("CFMT DEF9,BYTE,BIN") < 0)
	{
		free(trace_info->ptrRawData);
		trace_info->ptrRawData = NULL;
		trace_info->ulTrace_Size = 0;
		return -1;
	}
	
	sprintf(tmpStr, "%s:WF? ALL", trace_info->szTrace_Name);
	if (IM_QueryDevice(tmpStr, trace_info->ptrRawData, trace_info->ulTrace_Size + 256+346+4) < 0)
	{
		free(trace_info->ptrRawData);
		trace_info->ptrRawData = NULL;
		trace_info->ulTrace_Size = 0;
		return -1;
	}
	
	return 0;
}


static int CheckForNewSignal(void)
{

	char rspStr[512];
	int INR;
	

	
	IM_QueryDevice("INR?", rspStr, sizeof(rspStr));
	INR = atoi(rspStr);
	
	ProcessSystemEvents();
	
	if (INR & 0x0001)
		return TRUE;
	
	if (IM_QueryDevice("TRMD?", rspStr, sizeof(rspStr)) < 0)
		return FALSE;
	
	if (strstr(rspStr, "STOP"))
		strcpy(rspStr, "STOPPED");
	
	//response may be STOP, SINGLE, NORMAL, or AUTO
	rspStr[10] = NULL;// limit the string in case the DSO gets out of sync with the wave xfer.
	
	SetCtrlVal(gPanel_Info.hMainPanel, gPanel_Info.Misc_Controls.cxTrig_Mode_Text, rspStr);
	
	return FALSE;	

}


static int WriteWaveformToFile (TRACE_INFO *trace_info, char pathname[512])
{
	int handle, bytes_written;

	handle = OpenFile (pathname, VAL_WRITE_ONLY, VAL_TRUNCATE, VAL_BINARY);
	bytes_written = WriteFile (handle, trace_info->ptrRawData+4, trace_info->ulTrace_Size + 256+346);
	CloseFile (handle);
	return 0;

}




static int UpdateWaveforms(DSO_INFO *dso_info)
{

	int i, datalogger, stop_datalogger, index;
	char pathname[512], path[512], filename[512];
	
	for (i=TRACE_1; i<=TRACE_8; i++) 
	{
		if (dso_info->Trace[i].bTrace_ON == TRUE)
		{
			SetCtrlVal(gPanel_Info.hMainPanel, MAINPANEL_LED, TRUE);
			GetWaveform(&dso_info->Trace[i]);
			GetCtrlVal (gPanel_Info.hDataloggerPanel, DATALOGGER_DATALOGGER, &datalogger);
			GetCtrlVal (gPanel_Info.hDataloggerPanel, DATALOGGER_STOP_DATALOGGER, &stop_datalogger);
			// if Datalogger is ON and Stop is not pressed			
			if (datalogger)
			{
				SetCtrlVal (gPanel_Info.hDataloggerPanel, DATALOGGER_LED, ON);
				GetCtrlVal (gPanel_Info.hDataloggerPanel, DATALOGGER_PATH, path);
				GetCtrlVal (gPanel_Info.hDataloggerPanel, DATALOGGER_FILENAME, filename);
				GetCtrlVal (gPanel_Info.hDataloggerPanel, DATALOGGER_INDEX, &index);
				// create path+filename
				sprintf(pathname, "%s%s%s%s%s%s%d%s", path, "\\", filename, "_",gDSO_Info.Trace[i].szTrace_Name, "_", index, ".trc");
				WriteWaveformToFile (&dso_info->Trace[i], pathname);
				SetCtrlVal (gPanel_Info.hDataloggerPanel, DATALOGGER_LED, OFF);
			}
			SetCtrlVal(gPanel_Info.hMainPanel, MAINPANEL_LED, FALSE);
		}
	}
	SetCtrlVal (gPanel_Info.hDataloggerPanel, DATALOGGER_INDEX, ++index);
	UpdateSampleRateInfo();
	
	return 0;

}



void UpdateTrace(void)
{
	
	int i, first_trace = NO_VALUE;
	clock_t clk1;
	static float rate = 0.0;
	static int rate_count = 0;
	static double min=0, max=0;
	ULONG prev_trace_size = 0, max_trace_size = 0;
	char tmpStr[512];
	double offset, hmag, vmag;
	
	
	
	//find out if any of the trace is on
	for (i=TRACE_1; i<MAX_TRACE_COUNT; i++) 
	{
		if (gDSO_Info.Trace[i].bTrace_ON == TRUE)
		{
			first_trace = i;
			break;
		}
	}
	
	
	// return if non of the traces are on
	if (first_trace==NO_VALUE) 
	{
		SetCtrlVal(gPanel_Info.hMainPanel, gPanel_Info.Misc_Controls.cxUpdate_Rate_Text, "");
		return;
	}
	
	
	clk1 = clock();
	
	
	
	// retrieve waveforms
	if (strstr(gDSO_Info.szTrig_Mode, "STOP")==NULL)
	{
		// only update the waveform when trig mode is not STOP
		if (CheckForNewSignal() == TRUE) 
		{
			UpdateWaveforms(&gDSO_Info);
		}
	}
	
	
	if (gDSO_Info.bPersistence == FALSE)
	{
		DeleteGraphPlot (gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, -1, VAL_DELAYED_DRAW);
		DeleteGraphPlot (gPanel_Info.hMainPanel, gPanel_Info.cxScreen2, -1, VAL_DELAYED_DRAW);
	}

	
	
	// find which one has the longest trace
	for (i=TRACE_1; i<=TRACE_4; i++) 
	{
		if (gDSO_Info.Trace[i].bTrace_ON == FALSE)
			continue;
		if (gDSO_Info.Trace[i].ulTrace_Size > max_trace_size)
			max_trace_size = gDSO_Info.Trace[i].ulTrace_Size;
	}
	
	
	
	// adjust the scaling of the screen plot
	if (prev_trace_size != max_trace_size) 
	{
		// should be the same for all traces at the time of acquisition
		min = -((double) max_trace_size / 2.0);
		max = (double) max_trace_size / 2.0;
		SetAxisScalingMode (gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, VAL_XAXIS, VAL_MANUAL, min, max);
		SetAxisScalingMode (gPanel_Info.hMainPanel, gPanel_Info.cxScreen2, VAL_XAXIS, VAL_MANUAL, min, max);
		prev_trace_size = max_trace_size;
	}
	
	
	
	// plot the traces
	for (i=TRACE_1; i<=TRACE_8; i++) 
	{
		if (gDSO_Info.Trace[i].bTrace_ON == FALSE)
			continue;
		if (gDSO_Info.Trace[i].ptrRawData==NULL)
			continue;

		// if Math Trace TA ... TD
		if (strstr(gDSO_Info.Trace[i].szTrace_Name, "TA") ||
			strstr(gDSO_Info.Trace[i].szTrace_Name, "TB") ||
			strstr(gDSO_Info.Trace[i].szTrace_Name, "TC") ||
			strstr(gDSO_Info.Trace[i].szTrace_Name, "TD"))
		{
			// screen offset, only used in zoom traces otherwise zero offset
			offset = gDSO_Info.Trace[i].dZoom_Offset * 32;  // to display in DIV

			// Vertical Magnify, only used in zoom
			vmag = gDSO_Info.Trace[i].dZoom_VMAG;

			// Horizontal Magnify, only used in zoom
			hmag = gDSO_Info.Trace[i].dZoom_HMAG;

		}

		// if C1 .. C4
		else
		{
			// screen offset, only used in zoom traces otherwise zero offset
			offset = 0.0;

			// Vertical Magnify, only used in zoom
			vmag = 1.0;

			// Horizontal Magnify, only used in zoom
			hmag = 1.0;
		}
		
		if (gDSO_Info.iNum_Screen < 2) 
		{   // &gDSO_Info.Trace[i].ptrRawData+4+11+346 because 4 (ALL,), 11 (#9xxxxxxxxx), 346 (WAVEDESC)
			gPanel_Info.hPlotHandle[i] = PlotWaveform (gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, 
														gDSO_Info.Trace[i].ptrRawData+4+11+346,
                            							gDSO_Info.Trace[i].ulTrace_Size, VAL_CHAR, vmag, offset, min, 1.0*hmag, 
                            							VAL_CONNECTED_POINTS, VAL_NO_POINT,
                            							VAL_SOLID, 1, gDSO_Info.Trace[i].ulTrace_Color);
		}
		else 
		{
			if (gDSO_Info.Trace[i].iInfoBox_Index < TRACE_3) 
			{
				gPanel_Info.hPlotHandle[i] = PlotWaveform (gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, 
														&gDSO_Info.Trace[i].ptrRawData+4+11+346,
                            							gDSO_Info.Trace[i].ulTrace_Size, VAL_CHAR, vmag, offset, min, 1.0, 
                            							VAL_CONNECTED_POINTS, VAL_NO_POINT,
                            							VAL_SOLID, 1, gDSO_Info.Trace[i].ulTrace_Color);
			} 
			else 
			{
				gPanel_Info.hPlotHandle[i] = PlotWaveform (gPanel_Info.hMainPanel, gPanel_Info.cxScreen2, 
														gDSO_Info.Trace[i].ptrRawData+4+11+346,
                            							gDSO_Info.Trace[i].ulTrace_Size, VAL_CHAR, vmag, offset, min, 1.0, 
                            							VAL_CONNECTED_POINTS, VAL_NO_POINT,
                            							VAL_SOLID, 1, gDSO_Info.Trace[i].ulTrace_Color);
			}
		}
		
		
	}
	i = RefreshGraph (gPanel_Info.hMainPanel, gPanel_Info.cxScreen1);
	i = RefreshGraph (gPanel_Info.hMainPanel, gPanel_Info.cxScreen2);

	// calculate the rate based on average values
	rate += (float)CLOCKS_PER_SEC / (float)(clock() - clk1);
	++rate_count;
	if (rate_count >= 2) 
	{
		sprintf(tmpStr, "Update rate: %.1f/sec.", rate/rate_count);
		SetCtrlVal(gPanel_Info.hMainPanel, gPanel_Info.Misc_Controls.cxUpdate_Rate_Text, tmpStr);
		rate = 0.0;
		rate_count = 0.0;
	}
}
