/*
 *			Remote LSA
 *
 *			Copyright (c) 1998 LeCroy Corporation
 *			
 *			Written By: Ricardo Palacio
 *
 *			April, 1998
 *
 *
 */




/* 
 * $Header: /Test Framework 3/900040 Software Apps/LSA1000 GS/Net LSA/update_struct.c 2     6/23/98 10:39a Ricardop $
 * $Log: /Test Framework 3/900040 Software Apps/LSA1000 GS/Net LSA/update_struct.c $
 * 
 *
 * 4	03/06/01	Peter Wilhelm
 *					Added Update_HMAG
 * 
 * 3	12/18/00	Peter Wilhelm
 *					Modified DSO_Info.iMax_Channels = CHANNEL_2
 *					to gDSO_Info.iMax_Channels = CHANNEL_4; for supporting 4 channel scopes    
 *					Modified Update_DSO_Info - Enabled execition of Update_Chan_Coupling();
 *
 * 2     6/23/98 10:39a Ricardop
 * added *SRE 0 command
 * 
 * 1     4/27/98 4:54p Ricardop
 * Initial check-in
 * 
 */

#include <ansi_c.h>
#include <utility.h>
#include <userint.h>
#include <toolbox.h>
#include <analysis.h>
#include <formatio.h>
#include <toolbox.h>


// LeCroy Libs.
#include <interface.h>
#include <global_info.h>
#include <update_panel.h>
#include <dsopanel.h>


int Update_VDIV(void)
{

	int i;
	char rspStr[1024], tmpStr[512];

	// update vdiv
	for (i=CHANNEL_1; i<=gDSO_Info.iMax_Channels; i++) 
	{
		sprintf(tmpStr, "C%d:VDIV?", i);
		if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
			gDSO_Info.Trace[i].dVDIV = 1.0;
		else
			gDSO_Info.Trace[i].dVDIV = atof(rspStr);
	}
	
	return 0;
}




int Update_Chan_Offset(void)
{

	int i;
	char rspStr[1024], tmpStr[512];


	// update offset
	for (i=CHANNEL_1; i<=gDSO_Info.iMax_Channels; i++) 
	{
		sprintf(tmpStr, "C%d:OFST?", i);
		if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
			gDSO_Info.Trace[i].dOffset = 0.0;
		else
			gDSO_Info.Trace[i].dOffset = atof(rspStr);
	}
	
	return 0;
}





int Update_Attenuation(void)
{

	int i;
	char rspStr[1024], tmpStr[512];

	// update attenuation
	for (i=CHANNEL_1; i<=gDSO_Info.iMax_Channels; i++) 
	{
//		sprintf(tmpStr, "C%d:ATTN?", i);
//		if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
			gDSO_Info.Trace[i].dAttenuation = 1;
//		else 
//			gDSO_Info.Trace[i].dAttenuation = atof(rspStr);
	}
	
	return 0;
}



int Update_Chan_Coupling(void)
{

	int i;
	char rspStr[1024], tmpStr[512], *strPtr;

	
	// update channel coupling
	for (i=CHANNEL_1; i<=gDSO_Info.iMax_Channels; i++) 
	{
		sprintf(tmpStr, "C%d:CPL?", i);
		if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
			strcpy(gDSO_Info.Trace[i].szChan_Coupling, "");
		else
		{
			strPtr = strchr(rspStr, 0x0A);
			if (strPtr)
				*strPtr = NULL;
			strcpy(gDSO_Info.Trace[i].szChan_Coupling, rspStr);
		}
	}
	
	return 0;

}





int Update_TDIV(void)
{

	char rspStr[1024];

	// update tdiv
	if (IM_QueryDevice("TDIV?", rspStr, sizeof(rspStr)) < 0)
		gDSO_Info.dTDIV = 50.0e-9;
	else
		gDSO_Info.dTDIV = atof(rspStr);
	
	return 0;
}





int Update_Memory_Size(void)
{

	int i;
	char rspStr[1024], tmpStr[512], *strPtr;
	
	
	// update memory size
	if (IM_QueryDevice("MSIZ?", rspStr, sizeof(rspStr)) < 0)
	{
		strcpy(gDSO_Info.szMemory_Size, "500");
		gDSO_Info.ulMemory_Size = 500;
	}
	else
	{
	 	strPtr = strchr(rspStr, 0x0A);
	 	if (strPtr)
	 		*strPtr = NULL;
		StringUpperCase (rspStr);
		strcpy(gDSO_Info.szMemory_Size, rspStr);
	
		if (strPtr = strchr(rspStr, 'K'))
		{
			*strPtr = NULL;
			gDSO_Info.ulMemory_Size = atol(rspStr);
			gDSO_Info.ulMemory_Size *= 1000U;
		}
		else if (strPtr = strchr(rspStr, 'M'))
		{
			*strPtr = NULL;
			gDSO_Info.ulMemory_Size = atol(rspStr);
			gDSO_Info.ulMemory_Size *= 1000000U;
		}
		else
		{
		 	gDSO_Info.ulMemory_Size = atol(rspStr);
		}

	}
	
	return 0;
}


int Update_Trig_Type(void)
{

	int i_val;
	char rspStr[1024], tmpStr[512], *strPtr;

	// update trigger type
	if (IM_QueryDevice("TRSE?", rspStr, sizeof(rspStr)) < 0)
		strcpy(gDSO_Info.szTrig_Source, "");
	else
	{
		strPtr = strchr(rspStr, 0x0A);
		if (strPtr)
			*strPtr = NULL;
// 		Scan(rspStr, "%s>%s[dxt44]%s[dxt44]%s[xt44]", tmpStr);	reads channel of EDGE,SR,C1, ...
//		Scan(rspStr, "%s>%s[dxt44]%s[xt44]", tmpStr);			reads SR
		Scan(rspStr, "%s>%s[xt44]", tmpStr);				//	reads EDGE !
		
		strcpy(gDSO_Info.szTrig_Type, tmpStr);
	}
	
	return 0;
}





int Update_Trig_Source(void)
{

	int i_val;
	char rspStr[1024], tmpStr[512], *strPtr;

	// update trigger source
	if (IM_QueryDevice("TRSE?", rspStr, sizeof(rspStr)) < 0)
		strcpy(gDSO_Info.szTrig_Source, "");
	else
	{
		strPtr = strchr(rspStr, 0x0A);
		if (strPtr)
			*strPtr = NULL;
		Scan(rspStr, "%s>%s[dxt44]%s[dxt44]%s[xt44]", tmpStr);
		strcpy(gDSO_Info.szTrig_Source, tmpStr);
		Scan(tmpStr, "%s>%s[dt#]%d", &i_val);
		gDSO_Info.iTrig_Source = (i_val < MAX_CHANNEL_COUNT)? i_val:CHANNEL_1;
	}
	
	return 0;
}





int Update_Trig_Level(void)
{

	char rspStr[1024], tmpStr[512];


	// update trigger level
	if (strstr(gDSO_Info.szTrig_Source, "LINE"))
	    ;
	// else if (strstr(gDSO_Info.szTrig_Source, "EX"))				// 06.02.2001 PW
	//	  strcpy(tmpStr, "C1:TRLV?");
	else
	{
		sprintf(tmpStr, "%s:TRLV?", gDSO_Info.szTrig_Source);
		
		if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
			gDSO_Info.dTrig_Level = 0.0;
		else
			gDSO_Info.dTrig_Level = atof(rspStr);
	}
	return 0;
}



int Update_Trig_Coupling(void)
{

	char rspStr[1024], tmpStr[512], *strPtr;


	if (strstr(gDSO_Info.szTrig_Source, "LINE"))
		// strcpy(tmpStr, "C1:TRCP?");							// 06.02.2001 PW
		;
	else
	{
		sprintf(tmpStr, "%s:TRCP?", gDSO_Info.szTrig_Source);
		
		if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
		    strcpy(gDSO_Info.szTrig_Coupling, "DC");
		else
		{
			strPtr = strchr(rspStr, 0x0A);
    		if (strPtr)
				*strPtr = NULL;
			strcpy(gDSO_Info.szTrig_Coupling, rspStr);
		}
	}
	return 0;
}





int Update_Trig_Slope(void)
{

	char rspStr[1024], tmpStr[512];

	// Update trigger slope
	// if (strstr(gDSO_Info.szTrig_Source, "LINE"))
	//   strcpy(tmpStr, "C1:TRSL?");
	// else
	sprintf(tmpStr, "%s:TRSL?", gDSO_Info.szTrig_Source);
	
	if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
		gDSO_Info.bTrig_Slope = POSITIVE;
	else
	{
		if (strstr(rspStr, "POS"))
			gDSO_Info.bTrig_Slope = POSITIVE;
		else
			gDSO_Info.bTrig_Slope = NEGATIVE;
	}
	
	return 0;
}




int Update_Trig_Delay(void)
{

	char rspStr[1024];

	// Update trigger delay
	if (IM_QueryDevice("TRDL?", rspStr, sizeof(rspStr)) < 0)
		gDSO_Info.dTrig_Delay = 0;
	else
		gDSO_Info.dTrig_Delay = atof(rspStr);
	
	return 0;

}





int Update_Trig_Mode(void)
{

	char rspStr[1024], *strPtr;


	// Update trigger mode
	if (IM_QueryDevice("TRMD?", rspStr, sizeof(rspStr)) < 0)
		strcpy(gDSO_Info.szTrig_Mode, "");
	else
	{
		strPtr = strchr(rspStr, 0x0A);
		if (strPtr)
			*strPtr = NULL;
		strcpy(gDSO_Info.szTrig_Mode, rspStr);
	}
	
	return 0;
}


int Update_HMAG(void)
{

	int i;
	char rspStr[1024], tmpStr[512];

	// update HMAG
	for (i=CHANNEL_1; i<=gDSO_Info.iMax_Channels; i++) 
	{
		sprintf(tmpStr, "%s:HMAG?", gDSO_Info.Trace[i+4].szTrace_Name);
		if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
			gDSO_Info.Trace[i+4].dZoom_HMAG = 1.0;
		else
			gDSO_Info.Trace[i+4].dZoom_HMAG = atof(rspStr);
	}
	return 0;
}


int Update_HPOS(void)
{

	int i;
	char rspStr[1024], tmpStr[512];

	// update HPOS
	for (i=CHANNEL_1; i<=gDSO_Info.iMax_Channels; i++) 
	{
		sprintf(tmpStr, "%s:HPOS?", gDSO_Info.Trace[i+4].szTrace_Name);
		if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
			gDSO_Info.Trace[i+4].dZoom_Position = 1.0;
		else
			gDSO_Info.Trace[i+4].dZoom_Position = atof(rspStr);
	}
	return 0;
}


int Update_VMAG(void)
{

	int i;
	char rspStr[1024], tmpStr[512];

	// update VMAG
	for (i=CHANNEL_1; i<=gDSO_Info.iMax_Channels; i++) 
	{
		sprintf(tmpStr, "%s:VMAG?", gDSO_Info.Trace[i+4].szTrace_Name);
		if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
			gDSO_Info.Trace[i+4].dZoom_VMAG = 1.0;
		else
			gDSO_Info.Trace[i+4].dZoom_VMAG = atof(rspStr);
	}
	return 0;
}


int Update_VPOS(void)
{

	int i;
	char rspStr[1024], tmpStr[512];

	// update VPOS
	for (i=CHANNEL_1; i<=gDSO_Info.iMax_Channels; i++) 
	{
		sprintf(tmpStr, "%s:VPOS?", gDSO_Info.Trace[i+4].szTrace_Name);
		if (IM_QueryDevice(tmpStr, rspStr, sizeof(rspStr)) < 0)
			gDSO_Info.Trace[i+4].dZoom_Offset = 1.0;
		else
			gDSO_Info.Trace[i+4].dZoom_Offset = atof(rspStr);
	}
	return 0;
}




int Update_DSO_Info(void)
{


	Update_VDIV();
	Update_Chan_Offset();
	Update_Attenuation();
	Update_Chan_Coupling();
	Update_TDIV();
	Update_Memory_Size();
	Update_Trig_Type();
	Update_Trig_Source();
	Update_Trig_Level();
	Update_Trig_Coupling();
	Update_Trig_Slope();
	Update_Trig_Delay();
	Update_Trig_Mode();
	Update_HMAG();
	Update_HPOS();
	Update_VMAG();
	Update_VPOS();

	return 0;

}







int InitGlobalInfo(void)
{
    double min, max;
    int hProgress;
    char tmpStr[512];

	

	gDSO_Info.iMax_Channels = CHANNEL_4;
	
	
	hProgress = CreateProgressDialog ("Initializing", "Percent Complete", 1, VAL_NO_INNER_MARKERS, NULL);
	
	
	UpdateProgressDialog (hProgress, 10, 0);
	
	IM_WriteDevice("CHDR OFF");
	IM_WriteDevice("DISP OFF");
	IM_WriteDevice("*SRE 0");
//	IM_WriteDevice("TRMD AUTO");
//	IM_WriteDevice("TRDL 10");
//	IM_WriteDevice("ACAL OFF");
	
	if (IM_QueryDevice("*IDN?", tmpStr, sizeof(tmpStr)) < 0)
	{
		DiscardProgressDialog (hProgress);
		return -1;
	}
	
	UpdateProgressDialog (hProgress, 20, 0);
	Update_DSO_Info();
	
	
	UpdateProgressDialog (hProgress, 40, 0);
	UpdatePanel_Timebase(&gDSO_Info);

	UpdateProgressDialog (hProgress, 60, 0);
	UpdatePanel_Trigger(&gDSO_Info);

	
	UpdateProgressDialog (hProgress, 70, 0);
	UpdatePanel_Channel(&gDSO_Info);
	
	
	UpdateProgressDialog (hProgress, 80, 0);
	// update the initial screen limits
	SetAxisScalingMode (gPanel_Info.hMainPanel, gPanel_Info.cxScreen1, VAL_XAXIS, VAL_MANUAL, -200.0, 200.0);
	SetAxisScalingMode (gPanel_Info.hMainPanel, gPanel_Info.cxScreen2, VAL_XAXIS, VAL_MANUAL, -200.0, 200.0);

	
	ResetTimer (gPanel_Info.hMainPanel, MAINPANEL_TIMER);
	ResumeTimerCallbacks ();
	
	
	UpdateProgressDialog (hProgress, 90, 0);
	DiscardProgressDialog (hProgress);


	return 0;
}
