/* 
 * $Header: /Test Framework 3/LSA1000 GS/Test Tools/Sig_utils.c 1     4/27/98 4:55p Ricardop $
 * $Log: /Test Framework 3/LSA1000 GS/Test Tools/Sig_utils.c $
 * 
 * 1     4/27/98 4:55p Ricardop
 * Initial check-in
 * 
 */
//#include <txengine.h>
//#include <testexec.h>
#include <ansi_c.h>
#include <userint.h>

#include <lsa_tools.h>
#include <uut_util.h>

#include <inifile.h>
#include <interface.h>
#include <cvirte.h>    /* Needed if linking in external compiler; harmless otherwise */

static int gDAC_value;
static char gDAC_name[512];
static int sRampLoop = 1;
int gDacPanelHandle;
int sLdFePanelHandle;
int sLdConPanelHandle;
int gMainPanelHandle;
int gMemPanelHandle;
int gMDXPanelHandle;
int gMTBPanelHandle;
int gExitFlag = FALSE;

int FE_Utils (char *argstr)
{
	char tmpStr[512];
	int i;
	char *tmpPtr;
	

	// Load debug panel
	if ((gMainPanelHandle = LoadPanel (0, "lsa_tools.uir", MAIN_PANEL)) < 0)
		return -1;	
	DisplayPanel (gMainPanelHandle);
	
	
	
//	IM_LoadInstruments ("config.ini", tmpStr);
//	printf(tmpStr);
	
//	tmpPtr = malloc(1000000);
//	strcpy(tmpPtr, "*IDN?");
//	for (i=0; i<500; i++)
//	{
//		strcat(tmpPtr, "*IDN?");
// 	}
//	IM_WriteDevice(DSO, DEVICE_1, tmpPtr);
	
	gExitFlag = FALSE;
	while (gExitFlag != TRUE)
		ProcessSystemEvents();

	return 0;
}



// DAC panel Exit 
int CVICALLBACK UloadPanel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			sRampLoop = 0;
			DiscardPanel (gDacPanelHandle);
			SetCtrlAttribute (gMainPanelHandle, MAIN_PANEL_DAC_BTN, ATTR_DIMMED, 0);
			break;
	}
	return 0;
}

// LD_CON exit button																   	   
int CVICALLBACK Exit_ld_con (int panel, int control,  int event,  	   
		void *callbackData, int eventData1, int eventData2)		   	   
{																   	   
	switch (event) {											   	   
		case EVENT_COMMIT:										   	   
			DiscardPanel (sLdConPanelHandle);													   	   
			SetCtrlAttribute (gMainPanelHandle, MAIN_PANEL_LD_CON_BTN, ATTR_DIMMED, 0);
			break;												   	   
	}															   	   
	return 0;													   	   
}																   	   


//LD_FE exit button
int CVICALLBACK Unload_ld_fe_panel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			DiscardPanel (sLdFePanelHandle);
			SetCtrlAttribute (gMainPanelHandle, MAIN_PANEL_LD_FE_BTN, ATTR_DIMMED, 0);
			break;
	}
	return 0;
}

// main panel load 
int CVICALLBACK PanelLoad (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
   char cmdBuf[512];
   
   if (event != EVENT_COMMIT) 
   	return 0;              									   
	
	WriteDevice("CHDR OFF");
	
	switch (control)
	{		  // LD_FE button is pushed
		case MAIN_PANEL_LD_FE_BTN: 
			if ((sLdFePanelHandle = LoadPanel (0, "lsa_tools.uir", LD_FE_PAN)) < 0)
				return -1;
			DisplayPanel (sLdFePanelHandle);
			Set_LD_FE_panel(sLdFePanelHandle);
			SetCtrlAttribute (gMainPanelHandle, MAIN_PANEL_LD_FE_BTN, ATTR_DIMMED, 1);
			break;
			 // LD_con button is pushed
		case MAIN_PANEL_LD_CON_BTN:
			if ((sLdConPanelHandle = LoadPanel (0, "lsa_tools.uir", LD_CON)) < 0)
				return -1;
			DisplayPanel (sLdConPanelHandle);
			Set_LD_CON_panel(sLdConPanelHandle); 
			SetCtrlAttribute (gMainPanelHandle, MAIN_PANEL_LD_CON_BTN, ATTR_DIMMED, 1);     
			break;
			 // DAC button is pushed
		case MAIN_PANEL_DAC_BTN:
			if ((gDacPanelHandle = LoadPanel (0, "lsa_tools.uir", DACPANEL)) < 0)
				return -1;
			DisplayPanel (gDacPanelHandle);
			SetCtrlAttribute (gMainPanelHandle, MAIN_PANEL_DAC_BTN, ATTR_DIMMED, 1);			
			break;
			 // MEMORY button is pushed
		case MAIN_PANEL_MEM_BTN:
			if ((gMemPanelHandle = LoadPanel (0, "lsa_tools.uir", MEMPANEL)) < 0)
				return -1;
			DisplayPanel (gMemPanelHandle);
			SetCtrlAttribute (gMainPanelHandle, MAIN_PANEL_MEM_BTN, ATTR_DIMMED, 1);			
			break;
			 // MDX button is pushed
		case MAIN_PANEL_MDX_BTN:
			if ((gMDXPanelHandle = LoadPanel (0, "lsa_tools.uir", MDX)) < 0)
				return -1;
			DisplayPanel (gMDXPanelHandle);
			SetCtrlAttribute (gMainPanelHandle, MAIN_PANEL_MDX_BTN, ATTR_DIMMED, 1);			
			 // MTB button is pushed
			break;
		case MAIN_PANEL_MTB_BTN:
			if ((gMTBPanelHandle = LoadPanel (0, "lsa_tools.uir", MTB_PANEL)) < 0)
				return -1;
			DisplayPanel (gMTBPanelHandle);
			SetCtrlAttribute (gMainPanelHandle, MAIN_PANEL_MTB_BTN, ATTR_DIMMED, 1);			
			break;
			// EXIT button is pushed
		case MAIN_PANEL_EXIT_BTN:
			HidePanel(panel);
			gExitFlag = TRUE;
			break;
	}												      
	return 0;
}


