/*
 *			Remote LSA
 *
 *			Copyright (c) 1998 LeCroy Corporation
 *			
 *			Written By: Ricardo Palacio
 *
 *			April, 1998
 *
 *
 */


/* 
 * $Header: /Test Framework 3/LSA1000 GS/Utility/str_utils.c 1     4/27/98 4:54p Ricardop $
 * $Log: /Test Framework 3/LSA1000 GS/Utility/str_utils.c $
 * 
 * 1     4/27/98 4:54p Ricardop
 * Initial check-in
 * 
 */



#include <ansi_c.h>
#include <str_utils.h>


static char sString_Buffer[10240];



char *STR_MetricToString(double val, int dec_places, char *unit)
{
	
	char tmpStr[256];
	int neg_value = FALSE;
	
	if (val < 0) {
		neg_value = TRUE;
		val = fabs(val);
	}
	if (val < 0.9e-9) {// pico
		val *= 1.0e12;
		sprintf(tmpStr, "%s%%.%df p%s", (neg_value)? "-":"", dec_places, unit);
		sprintf(sString_Buffer, tmpStr, val);
		return sString_Buffer;
	}
	if (val < 0.9e-6) {// nano
		val *= 1.0e9;
		sprintf(tmpStr, "%s%%.%df n%s", (neg_value)? "-":"", dec_places, unit);
		sprintf(sString_Buffer, tmpStr, val);
		return sString_Buffer;
	}
	if (val < 0.9e-3) {// micro
		val *= 1.0e6;
		sprintf(tmpStr, "%s%%.%df u%s", (neg_value)? "-":"", dec_places, unit);
		sprintf(sString_Buffer, tmpStr, val);
		return sString_Buffer;
	}
	if (val < 0.9) {// milli
		val *= 1.0e3;
		sprintf(tmpStr, "%s%%.%df m%s", (neg_value)? "-":"", dec_places, unit);
		sprintf(sString_Buffer, tmpStr, val);
		return sString_Buffer;
	}
	if (val < 0.9e3) {// normal
		sprintf(tmpStr, "%s%%.%df %s", (neg_value)? "-":"", dec_places, unit);
		sprintf(sString_Buffer, tmpStr, val);
		return sString_Buffer;
	}
	if (val < 0.9e6) {// kilo
		val *= 1.0e-3;
		sprintf(tmpStr, "%s%%.%df K%s", (neg_value)? "-":"", dec_places, unit);
		sprintf(sString_Buffer, tmpStr, val);
		return sString_Buffer;
	}
	if (val < 0.9e9) {// mega
		val *= 1.0e-6;
		sprintf(tmpStr, "%s%%.%df M%s", (neg_value)? "-":"", dec_places, unit);
		sprintf(sString_Buffer, tmpStr, val);
		return sString_Buffer;
	}
	if (val < 0.9e12) {// giga
		val *= 1.0e-9;
		sprintf(tmpStr, "%s%%.%df G%s", (neg_value)? "-":"", dec_places, unit);
		sprintf(sString_Buffer, tmpStr, val);
		return sString_Buffer;
	}
	
	// anything else
	sprintf(tmpStr, "%s%%.%df %s", (neg_value)? "-":"", dec_places, unit);
	sprintf(sString_Buffer, tmpStr, val);
	return sString_Buffer;

}

