/* 
 * $Header: /Test Framework 3/LSA1000 GS/Test Tools/dac_utils.c 1     4/27/98 4:55p Ricardop $
 * $Log: /Test Framework 3/LSA1000 GS/Test Tools/dac_utils.c $
 * 
 * 1     4/27/98 4:55p Ricardop
 * Initial check-in
 * 
// */

#include <utility.h>
#include <inifile.h> 
#include <ansi_c.h>
#include <userint.h>
#include <cvirte.h>    /* Needed if linking in external compiler; harmless otherwise */
#include "sig_utils.h"
#include "interface.h"
#include <lsa_tools.h>
#include <uut_util.h>

static int gDAC_value;
static char gDAC_name[512];
static int sRampLoop = 1;

/*returns max code for selected DAC */
static int GetMaxDacCode (char *name)
{
	if (strcmp ("C1_HFE_VOFF", name) == 0)
	{
		return 4096;
	}
	else if (strcmp ("C1_HFE_VARG", name) == 0)
	{
		return 4096;
	}
	else if (strcmp ("C2_HFE_VOFF", name) == 0)
	{
		return 4096;
	}
	else if (strcmp ("C2_HFE_VARG", name) == 0)
	{
		return 4096;
	}
	else 
	{
		return 256;
	}
	return 0;

}	

// this function gets the dac name and dac value from panel
int CVICALLBACK ReadDacValue (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			GetCtrlVal(gDacPanelHandle, DACPANEL_DACVALUE, &gDAC_value); 
			GetCtrlVal(gDacPanelHandle, DACPANEL_RING, (char *)gDAC_name);
			break;
	}
	return 0;
}


// this funtion is called when udate or read button is pushed
int CVICALLBACK Execute (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char cmdBuf[512], *strP;
	
	
	
	if  (event != EVENT_COMMIT) 
		return 0;
			GetCtrlVal(gDacPanelHandle, DACPANEL_DACVALUE, &gDAC_value); 
			GetCtrlVal(gDacPanelHandle, DACPANEL_RING, (char *)gDAC_name);
	
	switch (control) {
		// write dac value to 900023
		case DACPANEL_UPDATE_BTN:
			sprintf(cmdBuf, "$$HA_DAC %s,%d", gDAC_name, gDAC_value);
			//printf(" %s\n", cmdBuf);
			WriteDevice (cmdBuf);
			break;
		 // write dac value to 900023  
		case DACPANEL_READ_BTN:
			sprintf(cmdBuf, "$$HA_DAC? %s", gDAC_name);			
			WriteDevice (cmdBuf);	
			//IM_WriteDevice (DSO, DEVICE_1, "CHAR OFF"); 
			ReadDevice(cmdBuf, 512);
			//IM_QueryDevice (DSO, DEVICE_1, cmdBuf, cmdBuf, 512);
			//sprintf(cmdBuf, "C2_HAD_VDEL_B, 237");	
			//printf(" %s\n", cmdBuf);
			if ((strP = strtok (cmdBuf,"," )) == NULL)
				break;
			strncpy (gDAC_name, strP, 16);
			
			if ((strP = strtok(NULL, ",")) == NULL)
				break ;
			sscanf(strP, "%d", &gDAC_value);
		//	SetCtrlVal(gDacPanelHandle, DACPANEL_RING, (char *)gDAC_name);
			SetCtrlVal(gDacPanelHandle, DACPANEL_DACVALUE, gDAC_value);
	}
	return 0;
}

// this function is called when Ramp dac button is pushed
int CVICALLBACK RampDAC (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	
	int i, max_code, running = FALSE;
	char cmdBuf[1024];
	gDAC_value = 0; 
	if (running == TRUE)
		return 0;
	switch (event) 
	{
		case EVENT_COMMIT:
		SetCtrlAttribute (gDacPanelHandle, DACPANEL_RAMP_BTN , ATTR_DIMMED, 1); 
		SetCtrlAttribute (gDacPanelHandle, DACPANEL_STOP_RAMP_BTN , ATTR_DIMMED, 0); 
		GetCtrlVal(gDacPanelHandle, DACPANEL_RING, (char *)gDAC_name);
		running = TRUE;
		max_code = GetMaxDacCode (gDAC_name);
		sRampLoop = 1;
		while (sRampLoop)
		{
			for (i=0; i<max_code; ++i)
			{
				sprintf(cmdBuf, "$$HA_DAC %s,%d", gDAC_name, i);
				Delay (0.001);
				WriteDevice (cmdBuf);
				//printf(" %s\n", cmdBuf);
				ProcessSystemEvents();
				if (!sRampLoop)
				{		
					break;
				}
			}
		}
		running = FALSE;
	}
	return 0;

}

/* Called when stop ramp button is pressed */
int CVICALLBACK StopRampDAC (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	if  (event != EVENT_COMMIT) 
		return 0;
	SetCtrlAttribute (gDacPanelHandle, DACPANEL_RAMP_BTN , ATTR_DIMMED, 0);        	
	SetCtrlAttribute (gDacPanelHandle, DACPANEL_STOP_RAMP_BTN , ATTR_DIMMED, 1);      
	sRampLoop = 0;
		
	
	return 0;
}

