#include "sig_utils.h"
#include <ansi_c.h>
#include <cvirte.h>		/* Needed if linking in external compiler; harmless otherwise */
#include <userint.h>
#include <uut_util.h>
#include "interface.h"
#include <lsa_tools.h>


// Here is an example function that would take a data structure and format the string to be sent to the scope:

void _LD_FE_data_to_string(unsigned char *serial_chain_data, char *buffer)
{
	
	unsigned char *charP;
	int i;

	/* charP starts initially pointing the first byte of serial_chain_data */
	charP = (unsigned char *)(serial_chain_data);

	/* start with a blank string */
	buffer[0] = '\0';

	for (i=0; i <6; i++)
	{
		/* append next hex value to string */
		sprintf(buffer, "%s%02X", buffer, (unsigned)(*charP));

		charP++;  /* advance to next byte of serial chain data */
	}

}

// Now, here's a function that goes in the opposite direction (takes the string of hex bytes and fills in the data structure:

void _LD_FE_string_to_data(char buffer[], unsigned char *serial_chain_data)
{
	unsigned char *charP;
	int i, value;
	char tmpStr[16];
	
	

	/* charP starts initially pointing the first byte of serial_chain_data */
	charP = (unsigned char *)(serial_chain_data);

	for (i=0; i <6; i++)
	{
	
		memcpy (tmpStr, &(buffer[2*i]), 2);
		tmpStr[3] = 0;
		/* extract next hex value from string */
		sscanf (tmpStr, "%2x", &value);

		/* copy byte to the serial data structure */
		*charP = (unsigned char)value;
		
		charP++;  /* advance to next byte of serial chain data */
	}

}

// Here is an example function that would take a data structure and format the string to be sent to the scope:

void _LD_CON_data_to_string(unsigned char *serial_chain_data, char *buffer)
{
	
	unsigned char *charP;
	int i;

	/* charP starts initially pointing the first byte of serial_chain_data */
	charP = (unsigned char *)(serial_chain_data);

	/* start with a blank string */
	buffer[0] = '\0';

	for (i=0; i < 4; i++)
	{
		/* append next hex value to string */
		sprintf(buffer, "%s%02X", buffer, (unsigned)(*charP));

		charP++;  /* advance to next byte of serial chain data */
	}

}

// Now, here's a function that goes in the opposite direction (takes the string of hex bytes and fills in the data structure:

void _LD_CON_string_to_data(char buffer[], unsigned char *serial_chain_data)
{
	unsigned char *charP;
	int i, value;
	char tmpStr[16];

	/* charP starts initially pointing the first byte of serial_chain_data */
	charP = (unsigned char *)(serial_chain_data);

	for (i=0; i < 4; i++)
	{
		memcpy (tmpStr, &(buffer[2*i]), 2);
		tmpStr[3] = 0;
		
		/* extract next hex value from string */
		sscanf(tmpStr, "%2x", &value);

		/* copy byte to the serial data structure */
		*charP = (unsigned char)value;
		
		charP++;  /* advance to next byte of serial chain data */
	}

	/* do something with serial_chain_data... */
}


// This function writes data to LD_FE serial rgister
int CVICALLBACK Udate_LD_FE (int panel, int control, int event,	   
		void *callbackData, int eventData1, int eventData2)		   
{																   
	
	
	
	unsigned short data;		   
	char cmdBuf[1024], dataBuf[1024]; 
    unsigned char ld_fe_reg[6];
    
    ld_fe_reg[0] =0;
    ld_fe_reg[1] =0;
    ld_fe_reg[2] =0;
    ld_fe_reg[3] =0;
    ld_fe_reg[4] =0;
    ld_fe_reg[5] =0;
   
   if (event != EVENT_COMMIT) 
   	return 0;              									   
   										   
		// Channel 2 MFE settings
		
		// byte 0	
			GetCtrlVal(panel, LD_FE_PAN_ENC_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[5] |=0x40;
			}
			GetCtrlVal(panel, LD_FE_PAN_ENB_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[5] |=0x20;
			}
			GetCtrlVal(panel, LD_FE_PAN_ENA_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[5] |=0x10;
			}
			GetCtrlVal(panel, LD_FE_PAN_G1_2, &data);	
			if (data)
			{
				ld_fe_reg[5] |=0x08;
			}
			GetCtrlVal(panel, LD_FE_PAN_G0_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[5] |=0x04;
			}
			GetCtrlVal(panel, LD_FE_PAN_BWL1_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[5] |=0x02;
			}
			GetCtrlVal(panel, LD_FE_PAN_BWL0_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[5] |=0x01;
			}
			
			// Channel 2 MTR settings
			
			//  bite 1							   	   
			GetCtrlVal(panel, LD_FE_PAN_LINON_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[3] |=0x04;
			}
			GetCtrlVal(panel, LD_FE_PAN_02ON_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[3] |=0x02;
			}
			GetCtrlVal(panel, LD_FE_PAN_01ON_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[3] |=0x01;
			}
	
			// bite 2
			GetCtrlVal(panel, LD_FE_PAN_WIND_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[4] |=0x80;
			}
			GetCtrlVal(panel, LD_FE_PAN_HF_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[4] |=0x40;
			}
			GetCtrlVal(panel, LD_FE_PAN_02NEG_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[4] |=0x20;
			}
			GetCtrlVal(panel, LD_FE_PAN_01NEG_2, &data);			   	   
			if (data)
			{
				ld_fe_reg[4] |=0x10;
			}
			GetCtrlVal(panel, LD_FE_PAN_DB1_2, &data);
			if (data)
			{
				ld_fe_reg[4] |=0x08;
			}
			GetCtrlVal(panel, LD_FE_PAN_DB0_2, &data);			       
			if (data)
			{
				ld_fe_reg[4] |=0x04;
			}
			GetCtrlVal(panel, LD_FE_PAN_HA1_2, &data);
			if (data)
			{
				ld_fe_reg[4] |=0x02;
			}
		
			GetCtrlVal(panel, LD_FE_PAN_HA0_2, &data);			       
			if (data)
			{
				ld_fe_reg[4] |=0x01;
			}
			

			
			
		//////////	
			 
		// Channel 1 MFE settings
		
		// byte 3	
			GetCtrlVal(panel, LD_FE_PAN_ENC_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[2] |=0x40;
			}
			GetCtrlVal(panel, LD_FE_PAN_ENB_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[2] |=0x20;
			}
			GetCtrlVal(panel, LD_FE_PAN_ENA_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[2] |=0x10;
			}
			GetCtrlVal(panel, LD_FE_PAN_G1_1, &data);	
			if (data)
			{
				ld_fe_reg[2] |=0x08;
			}
			GetCtrlVal(panel, LD_FE_PAN_G0_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[2] |=0x04;
			}
			GetCtrlVal(panel, LD_FE_PAN_BWL1_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[2] |=0x02;
			}
			GetCtrlVal(panel, LD_FE_PAN_BWL0_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[2] |=0x01;
			}
			
			// Channel 1 MTR settings
			
			//  bite 4							   	   
			GetCtrlVal(panel, LD_FE_PAN_LINON_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[0] |=0x04;
			}
			GetCtrlVal(panel, LD_FE_PAN_02ON_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[0] |=0x02;
			}
			GetCtrlVal(panel, LD_FE_PAN_01ON_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[0] |=0x01;
			}
	
			// bite 5
			GetCtrlVal(panel, LD_FE_PAN_WIND_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[1] |=0x80;
			}
			GetCtrlVal(panel, LD_FE_PAN_HF_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[1] |=0x40;
			}
			GetCtrlVal(panel, LD_FE_PAN_02NEG_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[1] |=0x20;
			}
			GetCtrlVal(panel, LD_FE_PAN_01NEG_1, &data);			   	   
			if (data)
			{
				ld_fe_reg[1] |=0x10;
			}
			GetCtrlVal(panel, LD_FE_PAN_DB1_1, &data);
			if (data)
			{
				ld_fe_reg[1] |=0x08;
			}
			GetCtrlVal(panel, LD_FE_PAN_DB0_1, &data);			       
			if (data)
			{
				ld_fe_reg[1] |=0x04;
			}
			GetCtrlVal(panel, LD_FE_PAN_HA1_1, &data);
			if (data)
			{
				ld_fe_reg[1] |=0x02;
			}
		
			GetCtrlVal(panel, LD_FE_PAN_HA0_1, &data);			       
			if (data)
			{
				ld_fe_reg[1] |=0x01;
			}
			

			
		
		

	_LD_FE_data_to_string(ld_fe_reg, dataBuf);
	sprintf(cmdBuf, "$$HA_SERIAL _LD_FE, \"%s\"",  dataBuf);    
	WriteDevice (cmdBuf);
	//printf("%s\n", cmdBuf);	
														   	   
												   	   
														   	   
	return 0;													   	   
}																   	   
																   	   
int CVICALLBACK Write_LD_CON (int panel, int control, int event,   	   
		void *callbackData, int eventData1, int eventData2)		   	   
{																   	   
	int data;		   
	char cmdBuf[1024], dataBuf[1024];
    unsigned char ld_con_reg[4];
    
    ld_con_reg[0] =0;
    ld_con_reg[1] =0;
    ld_con_reg[2] =0;
    ld_con_reg[3] =0;
												   	   
	if (event != EVENT_COMMIT)
		return 0;
			
			
			//first bite
			GetCtrlVal(panel, LD_CON_DIVIDER_6, &data);  
			if (data)
			{
				ld_con_reg[0] |=0x80;
			}
			GetCtrlVal(panel, LD_CON_DIVIDER_5, &data);			       	   
			if (data)
			{
				ld_con_reg[0] |=0x40;
			}
			GetCtrlVal(panel, LD_CON_DIVIDER_4, &data);			       	   
			if (data)
			{
				ld_con_reg[0] |=0x20;
			}
			GetCtrlVal(panel, LD_CON_DIVIDER_3, &data);			       	   
			if (data)
			{
				ld_con_reg[0] |=0x10;
			}
			GetCtrlVal(panel, LD_CON_DIVIDER_2, &data);			       	   
			if (data)
			{
				ld_con_reg[0] |=0x08;
			}
			GetCtrlVal(panel, LD_CON_DIVIDER_1, &data);			       	   
			if (data)
			{
				ld_con_reg[0] |=0x04;
			}
			GetCtrlVal(panel, LD_CON_DIVIDER_0, &data);			       	   
			if (data)
			{
				ld_con_reg[0] |=0x02;
			}
			GetCtrlVal(panel, LD_CON_EN_EXT_REF, &data);			       	   
			if (data)
			{
				ld_con_reg[0] |=0x01;
			}
			
			
			// second bite
			GetCtrlVal(panel, LD_CON_MDX_COUNT, &data);	
			if (data)
			{
				ld_con_reg[1] |=0x80;
			}
			
			GetCtrlVal(panel, LD_CON_CLKX1, &data);	
			if (data)
			{
				ld_con_reg[1] |=0x40;
			}
			
			GetCtrlVal(panel, LD_CON_500_SEL, &data);
			if (data)
			{
				ld_con_reg[1] |=0x20;
			}
			
			GetCtrlVal(panel, LD_CON_400_SEL, &data);
			if (data)
			{
				ld_con_reg[1] |=0x10;
			}
			
			GetCtrlVal(panel, LD_CON_PRE_DIV_3, &data);	
			if (data)
			{
				ld_con_reg[1] |=0x08;
			}
			
			GetCtrlVal(panel, LD_CON_PRE_DIV_2, &data);	
			if (data)
			{
				ld_con_reg[1] |=0x04;
			}
			
			GetCtrlVal(panel, LD_CON_PRE_DIV_1, &data);	
			if (data)
			{
				ld_con_reg[1] |=0x02;
			}
			
			GetCtrlVal(panel, LD_CON_PRE_DIV_0, &data);			       	   
			if (data)
			{
				ld_con_reg[1] |=0x01;
			}
				       	   
			// third bite		       	   
			GetCtrlVal(panel, LD_CON_CH2_ADC_CLK_DLY, &data);			   	   
						if (data)
			{
				ld_con_reg[2] |=0x40;
			}
			GetCtrlVal(panel, LD_CON_CH2_MDX_CLK_DLY, &data);		   
			if (data)
			{
				ld_con_reg[2] |=0x20;
			}
			GetCtrlVal(panel, LD_CON_CH2_HAD_A_SEL, &data);			   
			if (data)
			{
				ld_con_reg[2] |=0x10;
			}
			GetCtrlVal(panel, LD_CON_CH1_ADC_CLK_DLY, &data);			   	   
			if (data)
			{
				ld_con_reg[2] |=0x04;
			}
						   	   	   
			GetCtrlVal(panel, LD_CON_CH1_MDX_CLK_DLY, &data);		   
			if (data)
			{
				ld_con_reg[2] |=0x02;
			}
			
			GetCtrlVal(panel, LD_CON_CH1_HAD_A_SEL, &data);			   
			if (data)
			{
				ld_con_reg[2] |=0x01;
			}
			
			
			// fourth bite
			GetCtrlVal(panel, LD_CON_TRIG_SEL_2, &data);
			if (data)
			{
				ld_con_reg[3] |=0x20;
			}
			
			GetCtrlVal(panel, LD_CON_TRIG_SEL_1, &data);
			if (data)
			{
				ld_con_reg[3] |=0x10;
			}
			
			GetCtrlVal(panel, LD_CON_TRIG_SEL_0, &data);
			if (data)
			{
				ld_con_reg[3] |=0x08;
			}
			
			GetCtrlVal(panel, LD_CON_CAL_OSC, &data);
			if (data)
			{
				ld_con_reg[3] |=0x04;
			}
			
			GetCtrlVal(panel, LD_CON_CH1_RELAY, &data);	
			if (data)
			{
				ld_con_reg[3] |=0x02;
			}
			
			GetCtrlVal(panel, LD_CON_CH2_RELAY, &data);			   	   
			if (data)
			{
				ld_con_reg[3] |=0x01;
			}
				   	   
	
	
	_LD_CON_data_to_string(ld_con_reg, dataBuf);
	sprintf(cmdBuf, "$$HA_SERIAL _LD_CON, \"%s\"",  dataBuf);    
	WriteDevice (cmdBuf);
	//printf ("%s\n", cmdBuf);
	return 0;													   	   

}																   	   

// this function updates the LD_FE panel as read from signalizer 
void Set_LD_FE_panel(int panel)
{	
	unsigned short data;		   
	char cmdBuf[1024], buff[80]; 
	unsigned char ld_fe_reg[6];
   
   										   
			
	WriteDevice ("$$HA_SERIAL? _LD_FE");
	ReadDevice(cmdBuf, 1024); 
	// this command extracts rhe data field from command line  
	sscanf(cmdBuf, "%*[^\"]\"%[^\"]", buff);
	_LD_FE_string_to_data(buff, ld_fe_reg);
	
	
	
		
     // Channel 2 MFE settings 
	//  bite 0	
		SetCtrlVal(panel, LD_FE_PAN_ENC_2, (ld_fe_reg[5] &0x40) == 0x40);
		SetCtrlVal(panel, LD_FE_PAN_ENB_2, (ld_fe_reg[5] &0x20) == 0x20);			
		SetCtrlVal(panel, LD_FE_PAN_ENA_2, (ld_fe_reg[5] &0x10) == 0x10);
		SetCtrlVal(panel, LD_FE_PAN_G1_2, (ld_fe_reg[5] &0x08) == 0x08);
		SetCtrlVal(panel, LD_FE_PAN_G0_2, (ld_fe_reg[5] &0x04) == 0x04);
		SetCtrlVal(panel, LD_FE_PAN_BWL1_2, (ld_fe_reg[5] &0x02) == 0x02);
		SetCtrlVal(panel, LD_FE_PAN_BWL0_2, (ld_fe_reg[5] &0x01) == 0x01);			   	   
		   	   
	// Channel 2 MTR settings
	// bite 1 							   	   
		SetCtrlVal(panel, LD_FE_PAN_LINON_2, (ld_fe_reg[3] &0x04) == 0x04);
		SetCtrlVal(panel, LD_FE_PAN_02ON_2, (ld_fe_reg[3] &0x02) == 0x02);
		SetCtrlVal(panel, LD_FE_PAN_01ON_2, (ld_fe_reg[3] &0x01) == 0x01);			   	   
					   	   
	//  bite  2 				   	   
		SetCtrlVal(panel, LD_FE_PAN_WIND_2, (ld_fe_reg[4] &0x80) == 0x80);
   		SetCtrlVal(panel, LD_FE_PAN_HF_2, (ld_fe_reg[4] &0x40) == 0x40);
    	SetCtrlVal(panel, LD_FE_PAN_02NEG_2, (ld_fe_reg[4] &0x20) == 0x20);
    	SetCtrlVal(panel, LD_FE_PAN_01NEG_2, (ld_fe_reg[4] &0x10) == 0x10);
    	SetCtrlVal(panel, LD_FE_PAN_DB1_2, (ld_fe_reg[4] &0x08) == 0x08);
		SetCtrlVal(panel, LD_FE_PAN_DB0_2, (ld_fe_reg[4] &0x04) == 0x04);
		SetCtrlVal(panel, LD_FE_PAN_HA1_2, (ld_fe_reg[4] &0x02) == 0x02);
		SetCtrlVal(panel, LD_FE_PAN_HA0_2, (ld_fe_reg[4] &0x01) == 0x01);			       
		
		// Channel 1 MFE settings
		//third byte 3	
		SetCtrlVal(panel, LD_FE_PAN_ENC_1, (ld_fe_reg[1] &0x40) == 0x40);
		SetCtrlVal(panel, LD_FE_PAN_ENB_1, (ld_fe_reg[1] &0x20) == 0x20);
		SetCtrlVal(panel, LD_FE_PAN_ENA_1, (ld_fe_reg[1] &0x10) == 0x10);
		SetCtrlVal(panel, LD_FE_PAN_G1_1, (ld_fe_reg[1] &0x08) == 0x08);
		SetCtrlVal(panel, LD_FE_PAN_G0_1, (ld_fe_reg[1] &0x04) == 0x04);
		SetCtrlVal(panel, LD_FE_PAN_BWL1_1, (ld_fe_reg[1] &0x02) == 0x02);
		SetCtrlVal(panel, LD_FE_PAN_BWL0_1, (ld_fe_reg[1] &0x01) == 0x01);			   	   
		
		// Channel 1 MTR settings
 	    //  bite 4							   	   
		SetCtrlVal(panel, LD_FE_PAN_LINON_1, (ld_fe_reg[0] &0x04) == 0x04);
		SetCtrlVal(panel, LD_FE_PAN_02ON_1, (ld_fe_reg[0] &0x02) == 0x02);
		SetCtrlVal(panel, LD_FE_PAN_01ON_1, (ld_fe_reg[0] &0x01) == 0x01);			   	   
	   
        // first bite 5
		SetCtrlVal(panel, LD_FE_PAN_WIND_1, (ld_fe_reg[2] &0x80) == 0x80);
		SetCtrlVal(panel, LD_FE_PAN_HF_1, (ld_fe_reg[2] &0x40) == 0x40);
		SetCtrlVal(panel, LD_FE_PAN_02NEG_1, (ld_fe_reg[2] &0x20) == 0x20);
		SetCtrlVal(panel, LD_FE_PAN_01NEG_1, (ld_fe_reg[2] &0x10) == 0x10);
		SetCtrlVal(panel, LD_FE_PAN_DB1_1, (ld_fe_reg[2] &0x08) == 0x08);
		SetCtrlVal(panel, LD_FE_PAN_DB0_1, (ld_fe_reg[2] &0x04) == 0x04);
		SetCtrlVal(panel, LD_FE_PAN_HA1_1, (ld_fe_reg[2] &0x02) == 0x02);
		SetCtrlVal(panel, LD_FE_PAN_HA0_1, (ld_fe_reg[2] &0x01) == 0x01);			       
														   	   
	return ;													   	   
}																   	   


// this function updates the LD_CON panel as read from signalizer 
void Set_LD_CON_panel(int panel)
{	
	unsigned short data;		   
	char cmdBuf[1024], dataBuf[1024], buff [80], tmpBuf[1024]; 
	unsigned char ld_con_reg[4];
   
   										   
			
	WriteDevice ("$$HA_SERIAL? _LD_CON");
	ReadDevice(cmdBuf, 1024); 
	// this command extracts rhe data field from command line  
	sscanf(cmdBuf, "%*[^\"]\"%[^\"]", buff);
	_LD_CON_string_to_data(buff, ld_con_reg);
	
		// bite  0
		SetCtrlVal(panel, LD_CON_DIVIDER_6, (ld_con_reg[0] &0x80) == 0x80);  
		SetCtrlVal(panel, LD_CON_DIVIDER_5, (ld_con_reg[0] &0x40) == 0x40);			       	   
		SetCtrlVal(panel, LD_CON_DIVIDER_4, (ld_con_reg[0] &0x20) == 0x20);			       	   
		SetCtrlVal(panel, LD_CON_DIVIDER_3, (ld_con_reg[0] &0x10) == 0x10);			       	   
		SetCtrlVal(panel, LD_CON_DIVIDER_2, (ld_con_reg[0] &0x08) == 0x08);			       	   
		SetCtrlVal(panel, LD_CON_DIVIDER_1, (ld_con_reg[0] &0x04) == 0x04);			       	   
		SetCtrlVal(panel, LD_CON_DIVIDER_0, (ld_con_reg[0] &0x02) == 0x02);			       	   
		SetCtrlVal(panel, LD_CON_EN_EXT_REF, (ld_con_reg[0] &0x01) == 0x01);			       	   
		
		
		//  bite 1
		SetCtrlVal(panel, LD_CON_MDX_COUNT, (ld_con_reg[1] &0x80) == 0x80);	
		SetCtrlVal(panel, LD_CON_CLKX1, (ld_con_reg[1] &0x40) == 0x40);	
		SetCtrlVal(panel, LD_CON_500_SEL, (ld_con_reg[1] &0x20) == 0x20);
		SetCtrlVal(panel, LD_CON_400_SEL, (ld_con_reg[1] &0x10) == 0x10);
		SetCtrlVal(panel, LD_CON_PRE_DIV_3, (ld_con_reg[1] &0x08) == 0x08);	
		SetCtrlVal(panel, LD_CON_PRE_DIV_2, (ld_con_reg[1] &0x04) == 0x04);	
		SetCtrlVal(panel, LD_CON_PRE_DIV_1, (ld_con_reg[1] &0x02) == 0x02);	
		SetCtrlVal(panel, LD_CON_PRE_DIV_0, (ld_con_reg[1] &0x01) == 0x01);			       	   
			       	   
		//  bite 2		       	   
		SetCtrlVal(panel, LD_CON_CH2_ADC_CLK_DLY, (ld_con_reg[2] &0x40) == 0x40);			   	   
		SetCtrlVal(panel, LD_CON_CH2_MDX_CLK_DLY, (ld_con_reg[2] &0x20) == 0x20);		   
		SetCtrlVal(panel, LD_CON_CH2_HAD_A_SEL, (ld_con_reg[2] &0x10) == 0x10);			   
		SetCtrlVal(panel, LD_CON_CH1_ADC_CLK_DLY, (ld_con_reg[2] &0x04) == 0x04);			   	   
		SetCtrlVal(panel, LD_CON_CH1_MDX_CLK_DLY, (ld_con_reg[2] &0x02) == 0x02);		   
		SetCtrlVal(panel, LD_CON_CH1_HAD_A_SEL, (ld_con_reg[2] &0x01) == 0x01);			   
		
		//  bite 3
		SetCtrlVal(panel, LD_CON_TRIG_SEL_2, (ld_con_reg[3] &0x20) == 0x20);
		SetCtrlVal(panel, LD_CON_TRIG_SEL_1, (ld_con_reg[3] &0x10) == 0x10);
		SetCtrlVal(panel, LD_CON_TRIG_SEL_0, (ld_con_reg[3] &0x08) == 0x08);
		SetCtrlVal(panel, LD_CON_CAL_OSC, (ld_con_reg[3] &0x04) == 0x04);
		SetCtrlVal(panel, LD_CON_CH1_RELAY, (ld_con_reg[3] &0x02) == 0x02);	
		SetCtrlVal(panel, LD_CON_CH2_RELAY, (ld_con_reg[3] &0x01) == 0x01);			   	   
		
			return ;
}																   	   

